<?php
/*
Disclaimer and Copyright notice
PHPAdmin comes with no warranty and all the functionality contained within PHPAdmin is "as is". The author reserves the right to distribute PHPAdmin in the versions and methods as he sees fit.

Acknowledgements Made by Using PHPAdmin
You acknowledge that PHPAdmin is protected by copyright and/or trademark including but not limited to PHP webpage source files, designs, titles, and words or phrases which may be registered in certain jurisdictions (collectively, the "Content"). You agree to comply with any additional copyright notices, information, or restrictions contained in any Content. Modification or alteration of the Content is forbidden without express written consent of the author. Users of PHPAdmin may use the Content only for their personal, noncommercial use. Users of the Web Service wanting to use the content for commercial use must obtain prior express written permission of the author.

Contacting the Author
Should you have any questions regarding support, features, or the disclaimer, please contact the author via email at phpadmin@checkyour6.net.
*/

session_start();
$pcfg = new pa_config();


//MODIFY ONLY THIS
$dbhost = "MYSQL_IP";
$dbuser = "USERNAME";
$dbpass = "PASSWORD";
$database = "phpadmin";

$pcfg->setPublicUnban( TRUE );
$pcfg->setPublicList( FALSE );

//Example of Not Ventrilo or Mapcycle: $pcfg->addServer( "Server1", NULL, "cstrike", NULL );
$pcfg->addServer( "Server1", "C:/HLServer", "cstrike", "C:/Ventrilo" );
//END MODIFY

class pa_config {
	var $name, $ventrilo, $mod, $hldspath, $pubunban, $publist;
	function pa_config() {
		$this->name = array();
		$this->hldspath = array();
		$this->mod = array();
		$this->ventrilo = array();
		$this->pubunban = FALSE;
	}
	function setPublicUnban( $v ) {
		if( $v == TRUE ) {
			$this->pubunban = TRUE;
			return;
		}
		$this->pubunban = FALSE;
	}
	function setPublicList( $l ) {
		if( $l == TRUE ) {
			$this->publist = TRUE;
			return;
		}
		$this->publist = FALSE;	
	}
	function addServer( $n, $h, $m, $v ) {
		$pos = $this->getServerCount();
		$this->name[$pos] = $n;
		$this->hldspath[$pos] = $h;
		$this->mod[$pos] = $m;
		$this->ventrilo[$pos] = $v;
	}
	function getServerCount() {
		if( $this->name == NULL ) {
			return 0;
		}
		$temp = $this->name;
		return count( $temp );
	}
	function getServerAt( $id ) {
		if( $id >= $this->getServerCount() ) {
			return NULL;
		}
		return $this->name[$id];
	}
	function getVentriloAt( $id ) {
		if( $id >= $this->getServerCount() ) {
			return NULL;
		}
		return $this->ventrilo[$id];
	}
	function getModAt( $id ) {
		if( $id >= $this->getServerCount() ) {
			return NULL;
		}
		return $this->mod[$id];
	}
	function getHLDSPathAt( $id ) {
		if( $id >= $this->getServerCount() ) {
			return NULL;
		}
		return $this->hldspath[$id];
	}
	function getPubUnban() {
		return $this->pubunban;
	}
	function getPubList() {
		return $this->publist;
	}
}
class error {
	var $text, $ver;
	function error( $v ) {
		$this->ver = $v;
		$this->text = "";
	}
	function whicherror( $error ) {
		$content = "";
		switch( $error ) {
			case "catcode":
			case "subcode":
			$content = "<div align='center' class='titles'>Invalid SubCat ID!</div>";
			break;
			case "norecords":
			$content = "<div align='center' class='titles'>No Records Found!</div>";
			break;
			case "invalidid":
			$content = "<div align='center' class='titles'>Not a valid UserID!</div>";
			break;
			case "steamid":
			$content = "<div align='center' class='titles'>Not a valid SteamID!</div>";
			break;
			case "verify":
			$content = "<div align='center' class='titles'>There Are No BAN/GAG Requests!</div>";
			break;
			case "missing":
			$content = "<div align='center' class='titles'>You Are Missing or Have an Incorrect Field in the Form!</div>";
			break;
			case "duplicate":
			$content = "<div align='center' class='titles'>A Duplicate User Exists!</div>";
			break;
			case "publicunban":
			$content = "<div align='center' class='titles'>Public Unban Request Form is Not Active!</div>";
			break;
			case "noeditdel":
			$content = "<div align='center' class='titles'>There are no server configs to EDIT/DEL!</div>";
			break;
			case "filename":
			$content = "<div align='center' class='titles'>Invalid file extension format!</div>";
			break;
			case "mapcycle":
			$content = "<div align='center' class='titles'>Error updating the mapcycle!</div>";
			break;
			case "access":
			$content = "<div align='center' class='titles'>You Lack the Access to Process this Form!</div>";
			break;
			case "inuse":
			$content = "<div align='center' class='titles'>This record is still inuse! Meaning another record still references it.</div>";
			break;
			default:
			$content = "<div align='center' class='titles'>Bad Form Handler Code!</div>";
		}
		$content = "<br><br>$content<br><br>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $content );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_restrict {
	var $text, $display, $act, $id, $ver;
	function cat_restrict( $v ) {
		$this->ver = $v;
		$this->text  = "";
		$this->display = 20;
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		if( !$this->ver->hasAccess( "RestrictManager" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function addtag() {
		$title = "Add Tag Restriction Form";
		$username = $this->ver->getUsername();
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=restrict&sub=form_addtag' name='addtag'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td>Admin: $username</td>
		</tr>
		<tr>
		<td>Restrict Tag: <input type='text' name='addtag' maxlength='32' size='32' class='forms'></td>
		</tr>
		<tr>
		<td>Reason: <br><textarea name='tagreason' wrap='soft' rows='10' cols='75' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='center'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function deltag() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM restrictedtag";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Find Tag To Unrestrict";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=restrict&sub=deltag&id=$prevpos'>Previous $this->display Tags</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=restrict&sub=deltag&id=$nextpos'>Next $this->display Tags</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='60%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT id, regexp_tag, reason FROM restrictedtag ORDER BY id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $tagres = mysql_fetch_row($result) ) {
			$id = $tagres[0];
			$tag = $tagres[1];
			$reason = $tagres[2];
			$string .= "
			<tr>
			<td align='left'>Tag: $tag</td>
			<td align='right'><a href='index.php?cat=restrict&sub=form_deltag&tid=$id'>Unrestrict Tag?</a></td>
			</tr>
			<tr>
			<td colspan='2'>Reason for Restriction:<br>$reason</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function addip() {
		$title = "Add IP Restriction Form";
		$username = $this->ver->getUsername();
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=restrict&sub=form_addip' name='ip'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td align='right'>Admin: $this->username</td>
		</tr>
		<tr>
		<td align='right'>Restrict IP (Partial IP Ok):</td>
		<td align='left'><input type='text' name='addip' maxlength='15' size='15' class='forms'></td>
		</tr>
		<tr>
		<td align='right'>Name of IP User:</td>
		<td align='left'><input type='text' name='addipname' maxlength='32' size='15' class='forms'></td>
		</tr>
		<tr>
		<td colspan='2'>Reason: <br><textarea name='ipreason' wrap='soft' rows='10' cols='75' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='center' colspan='2'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function delip() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM restrictedip";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
		$title = "Find IP To Unrestrict";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=restrict&sub=delip&id=$prevpos'>Previous $this->display IPs</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=restrict&sub=delip&id=$nextpos'>Next $this->display IPs</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='60%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT id, regexp_ip, playername, reason FROM restrictedip ORDER BY id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $tagres = mysql_fetch_row($result) ) {
			$id = $tagres[0];
			$ip = $tagres[1];
			$name = $tagres[2];
			$reason = $tagres[3];
			$string .= "
			<tr>
			<td align='left'>IP: $ip ($name)</td>
			<td align='right'><a href='index.php?cat=restrict&sub=form_delip&iid=$id'>Unrestrict IP?</a></td>
			</tr>
			<tr>
			<td colspan='2'>Reason for Restriction:<br>$reason</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function addreveal() {
		$title = "Add Reveal List Form";
		$username = $this->ver->getUsername();
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=restrict&sub=form_addreveal' name='reveal'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td align='right'>Admin:</td>
		<td align='left'>$username</td>
		</tr>
		<tr>
		<td align='right'>Known User Name:</td>
		<td align='left'><input type='text' name='addusername' maxlength='32' size='15' class='forms'></td>
		</tr>
		<tr>
		<td align='right'>SteamID User:</td>
		<td align='left'><input type='text' name='addsteamid' maxlength='32' size='15' class='forms'></td>
		</tr>
		<tr>
		<td align='center' colspan='2'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function delreveal() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM reveal";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Find Reveal Name";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=restrict&sub=delreveal&id=$prevpos'>Previous $this->display Usernames</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=restrict&sub=delreveal&id=$nextpos'>Next $this->display Usernames</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='60%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT id, steamid, playername FROM reveal ORDER BY id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $reveallist = mysql_fetch_row($result) ) {
			$id = $reveallist[0];
			$steamid = $reveallist[1];
			$username = $reveallist[2];
			$string .= "
			<tr>
			<td align='left'>Username: $username<br> SteamID: $steamid</td>
			<td align='right'><a href='index.php?cat=restrict&sub=form_delreveal&rid=$id'>Remove Reveal?</a></td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_addtag() {
		$addtag = trim( $_POST['addtag'] );
		$tagreason = trim( htmlspecialchars( $_POST['tagreason'] ) );
		if( empty($addtag) || empty($tagreason) ) {
			$this->error( "missing" );
			return;
		}
		$addTagAction = "INSERT INTO restrictedtag VALUES ( 'LAST_INSERT_ID()+1', '$addtag', '$tagreason' )";
		mysql_query($addTagAction);
		$this->thankyou( "tagip" );
	}
	function form_deltag() {
		$tid = 0;
		if( isset( $_REQUEST['tid'] ) ) { $tid = $_REQUEST['tid']; }
		if( empty($tid) ) {
			$this->error( "missing" );
			return;
		}
		$tagAction = "DELETE FROM restrictedtag WHERE id = $tid";
		mysql_query($tagAction);
		$this->thankyou( "tagip" );
	}
	function form_addip() {
		$addip = trim( $_POST['addip'] );
		$addipname = trim( $_POST['addipname'] );
		$ipreason = trim( htmlspecialchars( $_POST['ipreason'] ) );
		if( empty($addip) || empty($addipname) || empty($ipreason) ) {
			$this->error( "missing" );
			return;
		}
		$addIPAction = "INSERT INTO restrictedip VALUES ( 'LAST_INSERT_ID()+1', '$addip', '$addipname', '$ipreason' )";
		mysql_query($addIPAction);
		$this->thankyou( "tagip" );
	}
	function form_delip() {
		$iid = 0;
		if( isset( $_REQUEST['iid'] ) ) { $iid = $_REQUEST['iid']; }
		if( empty($iid) ) {
			$this->error( "missing" );
			return;
		}
		$tagAction = "DELETE FROM restrictedip WHERE id = $iid";
		mysql_query($tagAction);
		$this->thankyou( "tagip" );
	}
	function form_addreveal() {
		$addsteamid = trim( $_POST['addsteamid'] );
		$addusername = trim( $_POST['addusername'] );
		if( empty($addusername) ) {
			$this->error( "missing" );
			return;
		}
		if( preg_match( "/^(STEAM_0:)[01]{1}[:]{1}[0-9]+$/", $addsteamid ) == 0 ) {
			$this->error( "steamid" );
			return;
		}
		$addRevealAction = "INSERT INTO reveal VALUES ( 'LAST_INSERT_ID()+1', '$addsteamid', '$addusername' )";
		mysql_query($addRevealAction);
		$this->thankyou( "reveal" );
	}
	function form_delreveal() {
		$rid = 0;
		if( isset( $_REQUEST['rid'] ) ) {
			$rid = $_REQUEST['rid'];
		}
		if( empty($rid) ) {
			$this->error( "missing" );
			return;
		}
		$revealAction = "DELETE FROM reveal WHERE id = $rid";
		mysql_query($revealAction);
		$this->thankyou( "reveal" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class default_html {
	var $ip, $text;
	function default_html( $ip ) {
		$this->text = "";
		$this->ip = $ip;
	}
	function tophalf() { $this->html_header(); }
	function bottomhalf() {
		$this->copyright();
		$this->html_footer();
	}
	function html_header() {
		$string = $this->text;
		$string .= "
		<html>
		<head>
		<title>.: PHPAdmin Control Panel :. </title>
		<link rel='stylesheet' href='styles.css' type='text/css'>
		</head>
		<body>
		<table width='95%' align='center' border='0' cellpadding='2' cellspacing='1'>
		<tr>
		<td valign='middle' align='center'>
		";
		$this->text = $string;
	}
	function copyright() {
		$string = $this->text;
		$year = date("Y");
		$string .= "
		<!-- Copyright Information -->
		<br>
		<table width='95%' align='center' border='0' cellpadding='2' cellspacing='1'>
		<tr valign='middle' align='center'>
		<td class='small' colspan='2'>Powered by <a href='http://www.checkyour6.net' target='_blank'>CheckYour6</a> v3.8 &copy; $year</td>
		</tr>
		</table>
		";
		$this->text = $string;
	}
	function html_footer() {
		$string = $this->text;
		$string .= "
		</td>
		</tr>
		</table>
		</body>
		</html>
		";
		$this->text = $string;
	}
	function addcontent( $middle ) {
		$string = $this->text;
		$string .= $middle;
		$this->text = $string;
	}
	function printtext() { echo("$this->text"); }
}
class cat_users {
	var $text, $sub, $ver, $pcfg;
	function cat_users( $v, $p ) {
		$this->ver = $v;
		$this->pcfg = $p;
		$this->text = "";
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		if( !$this->ver->hasAccess( "UserManager" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function add() {
		$title = "Add New Staff Member";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=form_add' name='add'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Alias:</td>
		<td align='left'><input class='forms' type='text' name='addusername' size='20' maxlength='32'></td>
		</tr>
		<tr>
		<td align='right'>Password:</td>
		<td align='left'><input class='forms' type='text' name='addpassword' size='20' maxlength='32'></td>
		</tr>
		<tr>
		<td align='right'>SteamID:</td>
		<td align='left'><textarea name='addsteamids' wrap='soft' rows='10' cols='50' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='right'>IrcAuth:</td>
		<td align='left'><input class='forms' type='text' name='addircauth' size='20' maxlength='200'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'>User Access on Servers</td>
		</tr>
		";
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$sname = $this->pcfg->getServerAt($i);
			$servervalue = pow( 2, $i );
			$string .= "
			<tr>
			<td>$sname <select class='forms' name='addservgroup[]'>
			";
			$res = mysql_query( "SELECT id, groupname FROM usergroups ORDER BY userlevel ASC" );
			while( $row = mysql_fetch_row($res) ) {
				$gid = $row[0];
				$name = $row[1];
				$string .= "<option value='$gid'>$name</option>";
			}
			$string .= "
			</select>
			</td>
			<td>Ventrilo Admin: <select class='forms' name='addventrilo[]'";
			$disabled = FALSE;
			if( $this->pcfg->getVentriloAt($i) == NULL ) {
				$disabled = TRUE;
				$string .= " disabled";
			}
			$string .= ">
			<option selected value='0'>No</option>
			<option value='1'>Yes</option>
			</select>
			<input type='hidden' name='disabledventrilo[]' value='";
			$string .= $disabled ? "1" : "0";
			$string .= "'>
			</td>
			</tr>
			";
		}
		$string .= "
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function preedit() {
		$action = "SELECT DISTINCT id, playername FROM staff ORDER BY id ASC";
		$result = mysql_query($action);
		$title = "Pre-Edit Staff Member";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=edit' name='preedit'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>User Alias: <select class='forms' name='edituserid'>
		";
		while( $data = mysql_fetch_row($result) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function edit() {
		$edituserid = $_POST['edituserid'];
		$action = "SELECT t1.playername, t1.password, t1.ircauth, t2.steamid FROM staff AS t1, steamids AS t2 WHERE t1.id = $edituserid AND t2.staffid = t1.id";
		$res = mysql_query($action);
		$username = 0;
		$password = "";
		$irc = 0;
		$sids = "";
		$cnt = 0;
		while( $userinfo = mysql_fetch_row($res) ) {
			if( $cnt > 0 ) { $sids .= "\n"; }
			$username = $userinfo[0];
			$password = $userinfo[1];
			$irc = $userinfo[2];
			$sids .= $userinfo[3];
			$cnt++;
		}
		$title = "Edit Staff Member";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=form_edit&edituserid=$edituserid' name='edit'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Alias:</td>
		<td align='left'><input class='forms' type='text' name='editusername' value='$username' size='20' maxlength='32'></td>
		</tr>
		<tr>
		<td align='right'>Password:</td>
		<td align='left'><input class='forms' type='text' name='editpassword' value='$password' size='20' maxlength='32'></td>
		</tr>
		<tr>
		<td align='right'>SteamID:</td>
		<td align='left'><textarea name='editsteamids' wrap='soft' rows='10' cols='50' class='forms'>$sids</textarea></td>
		</tr>
		<tr>
		<td align='right'>IRCAuth:</td>
		<td align='left'><input class='forms' type='text' name='editircauth' value='$irc' size='20' maxlength='39'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'>Userlevel on Servers</td>
		</tr>
		";
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$offset = $i - 1;
			$name = $this->pcfg->getServerAt($i);
			$servervalue = pow( 2, $offset );
			$action = "SELECT t3.id, t3.groupname FROM staff AS t1, servers AS t2, usergroups AS t3 WHERE t1.id = $edituserid AND t2.staffid = t1.id AND t2.usergroupid = t3.id ORDER BY t2.servervalue ASC";
			$res1 = mysql_query($action);
			$srow = mysql_fetch_row($res1);
			$ugid = $srow[0];
			$ugroupname = $srow[1];
			$string .= "
			<tr>
			<td align='right'>$name</td>
			<td align='left'><select class='forms' name='editservgroup[]'>
			<option value='$ugid' selected>$ugroupname</option>
			";
			$action = "SELECT id, groupname FROM usergroups WHERE id != $ugid ORDER BY userlevel ASC";
			$resg = mysql_query($action);
			while( $row = mysql_fetch_row( $resg ) ) {
				$gid = $row[0];
				$gname = $row[1];
				$string .= "<option value='$gid'>$gname</option>";
			}
			$string .= "
			</select>
			</td>
			<td>Ventrilo Admin: <select class='forms' name='editventrilo[]'";
			$disabled = FALSE;
			$isAdmin = "0";
			if( $this->pcfg->getVentriloAt($i) != NULL ) {
				$ic = new inicfg( $this->pcfg->getVentriloAt($i) . "/ventrilo_srv.usr" );
				$isAdmin = $ic->getValue( $username, "ServerAdmin" );
			} else {
				$disabled = TRUE;
				$string .= " disabled";
			}
			$string .= ">
			<option";
			if( $isAdmin == "0" ) { $string .= " selected"; }
			$string .= " value='0'>No</option>
			<option";
			if( $isAdmin == "1" ) { $string .= " selected"; }
			$string .= " value='1'>Yes</option>
			</select>
			<input type='hidden' name='disabledventrilo[]' value='";
			$string .= $disabled ? "1" : "0";
			$string .= "'>
			</td>
			</tr>
			";
		}
		$string .= "
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function del() {
		$action = "SELECT DISTINCT id, playername FROM staff ORDER BY id ASC";
		$result = mysql_query($action);
		$title = "Delete Staff Member";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=form_del' name='del'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>User Alias: <select class='forms' name='deluserid'>
		";
		while( $data = mysql_fetch_row($result) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function gadd() {
		$title = "Add New Usergroup";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=form_gadd' name='gadd'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Group Name:</td>
		<td align='left'><input class='forms' type='text' name='gname' size='10' maxlength='32'></td>
		</tr>
		<tr>
		<td align='right'>Server Level:</td>
		<td align='left'><input class='forms' type='text' name='gserverlevel' size='10' maxlength='10'></td>
		</tr>
		<tr>
		<td align='right'>Web Level:</td>
		<td align='left'><input class='forms' type='text' name='gweblevel' size='10' maxlength='39'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function gpreedit() {
		$action = "SELECT id, groupname FROM usergroups ORDER BY id ASC";
		$res = mysql_query($action);
		$title = "Pre-Edit Usergroup";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=gedit' name='gpreedit'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>UserGroup: <select class='forms' name='gid'>
		";
		while( $data = mysql_fetch_row($res) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function gedit() {
		$gid = $_POST['gid'];
		$action = "SELECT groupname, userlevel, weblevel FROM usergroups WHERE id = $gid";
		$res = mysql_query($action);
		$userinfo = mysql_fetch_row($res);
		$gname = $userinfo[0];
		$slevel = $userinfo[1];
		$wlevel = $userinfo[2];
		$title = "Edit Usergroup";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=form_gedit&gid=$gid' name='gedit'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Usergroup Name:</td>
		<td align='left'><input class='forms' type='text' name='gname' value='$gname' size='10' maxlength='50'></td>
		</tr>
		<tr>
		<td align='right'>Server Level:</td>
		<td align='left'><input class='forms' type='text' name='slevel' value='$slevel' size='10' maxlength='10'></td>
		</tr>
		<tr>
		<td align='right'>Web Level:</td>
		<td align='left'><input class='forms' type='text' name='wlevel' value='$wlevel' size='10' maxlength='10'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function gdel() {
		$action = "SELECT id, groupname FROM usergroups ORDER BY id ASC";
		$res = mysql_query($action);
		$title = "Delete Usergroup";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=users&sub=form_gdel' name='gdel'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>UserGroup: <select class='forms' name='gid'>
		";
		while( $data = mysql_fetch_row($res) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_add() {
		$addusername = trim( $_POST['addusername'] );
		$addpassword = trim( $_POST['addpassword'] );
		$addsteamids = trim( $_POST['addsteamids'] );
		$addsteamids .= "\r\n";
		$addircauth = trim( $_POST['addircauth'] );
		$addservgroup = $_POST['addservgroup'];
		$addventrilo = $_POST['addventrilo'];
		$disabledventrilo = $_POST['disabledventrilo'];
		if( empty($addusername) || empty($addpassword) || empty($addircauth) ) {
			$this->error( "missing" );
			return;
		}
		if( preg_match( "/^((STEAM_0:)[01]{1}[:]{1}[0-9]+\r\n)+$/", $addsteamids ) == 0 ) {
			$this->error( "steamid" );
			return;
		}
		$addsteamids = trim($addsteamids);
		$sids = explode( "\r\n", $addsteamids );
		$actionstaff = "INSERT INTO staff VALUES ( 'LAST_INSERT_ID()+1', '$addusername', '$addpassword', '$addircauth' )";
		mysql_query( $actionstaff );
		$actionstaffid = "SELECT id FROM staff WHERE playername = '$addusername'";
		$resid = mysql_query($actionstaffid);
		$row = mysql_fetch_row($resid);
		$staffid = $row[0];
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$groupvalue = $addservgroup[$i];
			$servervalue = pow( 2, $i );
			$addgame = "INSERT INTO servers VALUES ( 'LAST_INSERT_ID()+1', '$servervalue', '$staffid', '$groupvalue' )";
			mysql_query( $addgame );
		}
		for( $i = 0; $i < count($sids); $i++ ) {
			$sid = $sids[$i];
			$addgame = "INSERT INTO steamids VALUES ( 'LAST_INSERT_ID()+1', '$staffid', '$sid' )";
			mysql_query( $addgame );
		}
		$skew = 0;
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$offset = $i - $skew;
			if( $disabledventrilo[$i] == "0" ) {
				$ic = new inicfg( $this->pcfg->getVentriloAt($i) . "/ventrilo_srv.usr" );
				$ic->changeValue( $addusername, "UserPassword", $addpassword );
				$ic->changeValue( $addusername, "ServerAdmin", ($addventrilo[$offset] ? "1" : "0") );
				$ic->writeIni();
			} else {
				$skew++;
			}
		}
		$this->thankyou( "member" );
	}
	function form_edit() {
		$edituserid = 0;
		if( isset( $_REQUEST['edituserid'] ) ) {
			$edituserid = $_REQUEST['edituserid'];
		}
		$editusername = trim( $_POST['editusername'] );
		$editpassword = trim( $_POST['editpassword'] );
		$editsteamids = trim( $_POST['editsteamids'] );
		$editsteamids .= "\r\n";
		$editircauth = trim( $_POST['editircauth'] );
		$editservgroup = $_POST['editservgroup'];
		$editventrilo = $_POST['editventrilo'];
		$disabledventrilo = $_POST['disabledventrilo'];
		if( empty($edituserid) || empty($editpassword) || empty($editircauth) ) {
			$this->error( "missing" );
			return;
		}
		if( preg_match( "/^((STEAM_0:)[01]{1}[:]{1}[0-9]+\r\n)+$/", $editsteamids ) == 0 ) {
			$this->error( "steamid" );
			return;
		}
		$editsteamids = trim($editsteamids);
		$sids = explode( "\r\n", $editsteamids );
		$action = "UPDATE staff SET playername = '$editusername', password='$editpassword', ircauth='$editircauth' WHERE id = $edituserid";
		mysql_query($action);
		$action = "DELETE FROM servers WHERE staffid = $edituserid";
		mysql_query($action);
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$groupvalue = $editservgroup[$i];
			$servervalue = pow( 2, $i );
			$addgame = "INSERT INTO servers VALUES ( 'LAST_INSERT_ID()+1', '$servervalue', '$edituserid', '$groupvalue' )";
			mysql_query( $addgame );
		}
		$action = "DELETE FROM steamids WHERE staffid = $edituserid";
		mysql_query($action);
		for( $i = 0; $i < count($sids); $i++ ) {
			$sid = $sids[$i];
			$addgame = "INSERT INTO steamids VALUES ( 'LAST_INSERT_ID()+1', '$edituserid', '$sid' )";
			mysql_query( $addgame );
		}
		$skew = 0;
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$offset = $i - $skew;
			if( $disabledventrilo[$i] == "0" ) {
				$ic = new inicfg( $this->pcfg->getVentriloAt($i) . "/ventrilo_srv.usr" );
				$ic->changeValue( $editusername, "UserPassword", $editpassword );
				$ic->changeValue( $editusername, "ServerAdmin", ($editventrilo[$offset] ? "1" : "0") );
				$ic->writeIni();
			} else {
				$skew++;
			}
		}
		$this->thankyou( "member" );
	}
	function form_del() {
		$deluserid = trim( $_POST['deluserid'] );
		if( empty($deluserid) ) {
			$this->error( "missing" );
			return;
		}
		$actionstaffid = "SELECT playername FROM staff WHERE id = $deluserid";
		$res = mysql_query($actionstaffid);
		$row = mysql_fetch_row($res);
		$delusername = $row[0];
		$action = "DELETE FROM staff WHERE id = $deluserid";
		mysql_query( $action );
		$action = "DELETE FROM servers WHERE staffid = $deluserid";
		mysql_query( $action );
		$action = "DELETE FROM steamids WHERE staffid = $deluserid";
		mysql_query( $action );
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			if( $this->pcfg->getVentriloAt($i) != NULL ) {
				$ic = new inicfg( $this->pcfg->getVentriloAt($i) . "/ventrilo_srv.usr" );
				$ic->deleteKey( $delusername );
				$ic->writeIni();
			}
		}
		$this->thankyou( "member" );
	}
	function form_gadd() {
		$gname = trim( $_POST['gname'] );
		$gserverlevel = trim( $_POST['gserverlevel'] );
		$gweblevel = trim( $_POST['gweblevel'] );
		$action = "SELECT id FROM usergroups WHERE userlevel = $gserverlevel AND weblevel = $gweblevel";
		$res1 = mysql_query($action);
		if( mysql_num_rows($res1) != 0 ) {
			$this->error( "duplicate" );
			return;
		}
		$action = "INSERT INTO usergroups VALUES ( 'LAST_INSERT_ID()+1', '$gname', '$gserverlevel', '$gweblevel' )";
		mysql_query($action);
		$this->thankyou( "group" );
	}
	function form_gedit() {
		$gid = trim( $_REQUEST['gid'] );
		$gname = trim( $_POST['gname'] );
		$slevel = trim( $_POST['slevel'] );
		$wlevel = $_POST['wlevel'];
		$action = "UPDATE usergroups SET groupname='$gname', userlevel = $slevel, weblevel = $wlevel WHERE id = $gid";
		mysql_query($action);
		$this->thankyou( "group" );
	}
	function form_gdel() {
		$gid = trim( $_POST['gid'] );
		$action = "SELECT id FROM staff WHERE usergroup = $gid";
		$res1 = mysql_query( $action );
		if( mysql_num_rows($res1) == 0  ) {
			$action = "DELETE FROM usergroups WHERE id = $gid";
			mysql_query($action);
			$this->thankyou( "group" );
			return;
		}
		$this->error( "inuse" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_filter {
	var $text, $id, $ver, $display;
	function cat_filter( $v ) {
		$this->ver = $v;
		$this->text = "";
		$this->display = 20;
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		if( !$this->ver->hasAccess( "FilterReplace" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function add() {
		$title = "Add New Filter/Replace";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=filter&sub=form_add' name='addfilter'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Filter:</td>
		<td align='left'><input class='forms' type='text' name='addfilter' size='15' maxlength='50'></td>
		</tr>
		<tr>
		<td align='right'>Replace With<br>(Blank If No Replacement):</td>
		<td align='left'><input class='forms' type='text' name='addreplace' size='15' maxlength='50'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function del() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$totalaction = "SELECT COUNT(*) FROM filterreplace";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
 		$title = "Find Filter To Remove";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=filter&sub=del&id=$prevpos'>Previous $this->display Filter</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=filter&sub=del&id=$nextpos'>Next $this->display Filter</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='60%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT * FROM filterreplace ORDER BY id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $filterrow = mysql_fetch_row($result) ) {
			$fid = $filterrow[0];
			$filter = $filterrow[1];
			$replace = $filterrow[2];
			$string .= "
			<tr>
			<td align='left'>Filter/Replace:<br>$filter/$replace</td>
			<td align='right'><a href='index.php?cat=filter&sub=form_del&fid=$fid'>Remove Filter?</a></td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "
		</table>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_add() {
		$addfilter = trim( $_POST['addfilter'] );
		$addreplace = trim( $_POST['addreplace'] );
		if( empty($addfilter) ) {
			$this->error( "missing" );
			return;
		}
		if( empty($addreplace) ) {
			$addreplace = "NONE";
		}
		mysql_query( "INSERT INTO filterreplace VALUES ( 'LAST_INSERT_ID()+1', '$addfilter', '$addreplace' )" );
		$this->thankyou( "filter" );
	}
	function form_del() {
		$fid = trim( $_REQUEST['fid'] );
		if( empty($fid) ) {
			$this->error( "missing" );
			return;
		}
		mysql_query( "DELETE FROM filterreplace WHERE id = $fid" );
		$this->thankyou( "filter" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_gag {
	var $text, $display, $sub, $id, $ver;
	function cat_gag( $v ) {
		$this->ver = $v;
		$this->text  = "";
		$this->display = 20;
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		$levelneeded = "GagMenu";
		if( $this->act == "gagverf" || $this->sub == "form_verf" ) { $levelneeded = "BanGagManager"; }
		if( !$this->ver->hasAccess( $levelname ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function gag() {
		$username = $this->ver->getUsername();
		$title = "Gag Request Form";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=gag&sub=form_gag' name='gag'>
		<table class='text' align='center' width='80%' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td align='right'>Admin:</td>
		<td align='left'>$username</td>
		</tr>
		<tr>
		<td align='right'>Player Name:</td>
		<td align='left'><input type='text' name='gagname' maxlength='32' size='32' class='forms'></td>
		</tr>
		<tr>
		<td align='right'>Gag SteamID:</td>
		<td align='left'><input type='text' name='gagsteamid' maxlength='39' size='15' class='forms'></td>
		</tr>
		<tr>
		<td colspan='2'>Reason: <br><textarea name='gagreason' wrap='soft' rows='10' cols='75' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='center' colspan='2'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function search() {
		$search = $_POST['search'];
		$action = "SELECT id, steamid, name, time, actionid, reason FROM gagged WHERE (steamid REGEXP '$search' OR name REGEXP '$search') AND (status & 4) = 4 ORDER BY id ASC";
		$result = mysql_query($action);
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "norecords" );
			return;
		}
		$title = "Find Player To Request Ungag";
		$string = "
		<div class='titles' align='center'>$title</div>
		<br>
		<form method='post' action='index.php?cat=gag&sub=search' name='search'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Search by SteamID or Name: <input type='text' name='search' class='forms' size='20'></td>
		</tr>
		<tr>
		<td align='right'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		<br>
		<div align='center' class='text'>Player Name or Steamid Matches</div>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td colspan='2'>&nbsp;</td>
		</tr>
		";
		while( $findplayer = mysql_fetch_row($result) ) {
			$gaggedid = $findplayer[0];
			$gaggedsid = $findplayer[1];
			$gaggedname = $findplayer[2];
			$gaggedtime = $findplayer[3];
			$gaggedadmin = $findplayer[4];
			$gaggedreason = $findplayer[5];
			$gaggedadmin = $this->ver->authid2username($gaggedadmin);
			$string .= "
			<tr>
			<td align='left'>Player: $gagnedname</td>
			<td align='right'><a href='index.php?cat=gag&sub=ungag&id=$gaggedid&sid=$gaggedsid'>Ungag Player?</a></td>
			</tr>
			<tr>
			<td align='left'>Gagged AuthID: $gaggedsid</td>
			<td align='right'>Gagged By: $gaggedadmin</td>
			</tr>
			";
			if( $gaggedtime != 0 ) {
				$string .= "<tr>
				<td colspan='2'>Temporary Gag Length: $gaggedtime</td>
				</tr>";
			}
			$string .= "
			<tr>
			<td colspan='2'>Reason for Gag:<br>$gaggedreason</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function preungag() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM gagged";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Find Player To Request Ungag";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=gag&sub=search' name='search'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Search by SteamID or Name: <input type='text' name='search' class='forms' size='20'></td>
		</tr>
		<tr>
		<td align='right'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		<br>
		<div class='text' align='center'>Browse Complete Player Gag List</div>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr width='100%'>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=gag&sub=preungag&id=$prevpos'>Previous $this->display Gags</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=gag&sub=preungag&id=$nextpos'>Next $this->display Gags</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT id, steamid, name, time, actionid, reason FROM gagged WHERE (status & 4) = 4 ORDER BY id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $findplayer = mysql_fetch_row($result) ) {
			$gaggedid = $findplayer[0];
			$gaggedsid = $findplayer[1];
			$gaggedname = $findplayer[2];
			$gaggedtime = $findplayer[3];
			$gaggedadmin = $findplayer[4];
			$gaggedreason = $findplayer[5];
			$gaggedadmin = $this->ver->authid2username($gaggedadmin);
			$string .= "
			<tr>
			<td align='left'>Player: $gaggedname</td>
			<td align='right'><a href='index.php?cat=gag&sub=ungag&id=$gaggedid&sid=$gaggedsid'>Ungag Player?</a></td>
			</tr>
			<tr>
			<td align='left'>Gagged AuthID: $gaggedsid</td>
			<td align='right'>Gagged By: $gaggedadmin</td>
			</tr>
			";
			if( $gaggedtime != 0 ) {
				$string .= "<tr>
				<td colspan='2'>Temporary Gag Length: $gaggedtime</td>
				</tr>";
			}
			$string .= "
			<tr>
			<td colspan='2'>Reason for Gag:<br>$gaggedreason</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function ungag() {
		if( empty($this->id) ) {
			$this->error( "invalidid" );
			return;
		}
		$sid = $_REQUEST['sid'];
		$string = $this->text;
		$username = $this->ver->getUsername();
		$title = "Ungag Request Form";
		$string = "
		<div align='center' class='text'>$title</div>
		<br>
		<form method='post' action='index.php?cat=gag&sub=form_ungag&ungagid=$this->id' name='ungag'>
		<table class='text' align='center' width='80%' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td>&nbsp;</td>
		</tr>
		<tr>
		<td>Admin: $username</td>
		</tr>
		<tr>
		<td>Ungag SteamID: $sid</td>
		</tr>
		<tr>
		<td>Reason for Ungag: <br><textarea name='ungagreason' wrap='soft' rows='10' cols='75' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='center'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
 	function verify() {
		$string = $this->text;
		$action = "SELECT id, steamid, name, actionid, reactionid, reason, reactreason, status FROM gagged WHERE (status & 3) != 0 ORDER BY id ASC";
		$result = mysql_query($action);
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "norecords" );
			return;
		}
		$title = "Verify Gag/Ungag Requests Form";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=gag&sub=form_verf' name='gagverf'>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		";
 		while( $request = mysql_fetch_row($result) ) {
			$id = $request[0];
			$steamid = $request[1];
			$name = $request[2];
			$gagadmin = $request[3];
			$ungagadmin = $request[4];
			$gagreason = $request[5];
			$ungagreason = $request[6];
			$status = $request[7];
			$gagadmin = $this->ver->authid2username($gagadmin);
			$ungagadmin = $this->ver->authid2username($ungagadmin);
			$statusStr = "";
			if( ($status & 2) == 2 )
			{
				$statusStr = "Gag";
				$adminname = $gagadmin;
			} else {
				$statusStr = "Ungag";
				$adminname = $ungagadmin;
			}
			$arrayFindthis = array( "^\t^" );
			$arraySubwith = array( "<br>" );
			$name = preg_replace( $arrayFindthis, $arraySubwith, $name );
			$string .= "
			<tr>
			<td align='left' width='50%'><strong>Gag-ee:</strong> $name / $steamid</td>
			<td align='right' width='50%'><strong>Requesting Admin:</strong> $adminname</td>
			</tr>
			<tr>
			<td colspan='2'  width='100%'><strong>Gag Reason:</strong><br>$gagreason</td>
			</tr>
			";
 			if( ($status & 1) == 1 ) {
				$string .= "<tr>
				<td colspan='2'><strong>Ungag Reason:</strong><br>$ungagreason</td>
				</tr>";
			}
			$string .= "
			<tr>
			<td colspan='2'><strong>Approve $statusStr?:</strong>
			<select class='forms' name='approve[]'>
			<option>Y</option>
			<option selected>N</option>
			</select>
			</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "
		<tr>
		<td align='center' colspan='2'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function log() {
		$pos = $this->id;
		if( empty($pos) || !is_numeric($pos) ) { $pos = 0; }
		$totalaction = "SELECT COUNT(*) FROM logged WHERE type = 2";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Viewing Admin Logs";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr width='100%'>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=gag&sub=log&=$prevpos'>Previous $this->display Gags Actions</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=gag&sub=log&id=$nextpos'>Next $this->display Gags Actions</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT timestamp, actionid, action FROM logged WHERE type = 2 ORDER BY timestamp DESC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $getlog = mysql_fetch_row($result) ) {
			$time = $getlog[0];
			$sid = $getlog[1];
			$logaction = $getlog[2];
			$adminname = $this->ver->authid2username( $sid );
			$dateformatted = date( "l F j, Y", $time );
			$string .= "
			<tr>
			<td align='left'>Date: $dateformatted</td>
			<td align='right'>Admin: $adminname</td>
			</tr>
			<tr>
			<td colspan='2'>Action Performed:<br>$logaction</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_gag() {
		$gagname = trim( htmlspecialchars( $_POST['gagname'] ) );
		$gagsteamid = trim( $_POST['gagsteamid'] );
		$gagreason = trim( htmlspecialchars( $_POST['gagreason'] ) );
		if( preg_match( "/^(STEAM_0:)[01]{1}[:]{1}[0-9]+$/", $gagsteamid ) == 0 ) {
			$this->error( "steamid" );
			return;
		}
		if( empty($gagname) || empty($gagreason) ) {
			$this->error( "missing" );
			return;
		}
		$userTempGagged = "SELECT status FROM gagged WHERE steamid='$gagsteamid'";
		$resultTemp = mysql_query($userTempGagged);
		if( mysql_num_rows($resultTemp) != 0 ) {
			$this->error( "duplicate" );
			return;
		}
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$level = $this->ver->hasAccess( "BanGagManager" );
		$timestamp = time();
		$addAction = "INSERT INTO gagged VALUES ( 'LAST_INSERT_ID()+1', '$gagsteamid', '$gagname', '$timestamp', '0', '";
		if( $level ) {
			$addAction .= "20";
		} else {
			$addAction .= "18";
		}
		$addAction .= "', '1', '0', '$userauth', '0', '$gagreason', 'NA' )";
		mysql_query( $addAction );
		$logtheaction = "$username ($userauth) ";
		if( $level ) {
			$logtheaction .= "gagged ";
		} else {
			$logtheaction .= "requested a permanent gag on ";
		}
		$logtheaction .= "$gagname ($gagsteamid) because $gagreason.";
		$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '2', '$timestamp', '$userauth', '$username', '$gagsteamid', '$gagname', '$logtheaction' )";
		mysql_query( $logaction );
		$this->thankyou( "gag" );
	}
	function form_ungag() {
		$ungagid = 0;
		if( isset( $_REQUEST['ungagid'] ) ) { $ungagid = $_REQUEST['ungagid']; }
		$ungagreason = trim( htmlspecialchars( $_POST['ungagreason'] ) );
		$actionName = "SELECT name, steamid, status FROM gagged WHERE id = $ungagid";
		$getName = mysql_query( $actionName );
		if( mysql_num_rows($getName) == 0 ) {
			$this->error( "invalidid" );
			return;
		}
		if( empty($ungagreason) ) {
			$this->error( "missing" );
			return;
		}
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$level = $this->ver->hasAccess( "BanGagManager" );
		$getNameRow = mysql_fetch_row($getName);
		$ungagname = $getNameRow[0];
		$ungagsteamid = $getNameRow[1];
		$ungagstatus = $getNameRow[2];

		$ungagaction = "UPDATE gagged SET ";
		if( $level ) {
			$ungagaction .= "status = 32, action = 0, ";
		} else {
			$dif = ($ungagstatus & 3);
			$ungagstatus = ($ungagstatus - $dif) | 1;
			$ungagaction .= "status = $ungagstatus, ";
		}
		$ungagaction .= "reactionid='$userauth', reactreason='$ungagreason' WHERE id = $ungagid";
		mysql_query( $ungagaction );
		$timestamp = time();
		$logtheaction = "$username ($userauth) ";
		if( $this->userlevel ) {
			$logtheaction .= "ungagged ";
		} else {
			$logtheaction .= "requested to ungag ";
		}
		$logtheaction .= "$ungagname ($ungagsteamid) because $ungagreason.";
		$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '2', '$timestamp', '$userauth', '$username', '$ungagsteamid', '$ungagname', '$logtheaction' )";
		mysql_query( $logaction );
		$this->thankyou( "gag" );
	}
	function form_verf() {
		$approve = $_POST['approve'];
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$verfaction = "SELECT id, steamid, name, status FROM gagged WHERE (status & 3) != 0 ORDER BY id ASC";
		$verfresult = mysql_query($verfaction);
		$cnt = 0;
		while( $verf = mysql_fetch_row($verfresult) ) {
			$id = $verf[0];
			$steamid = $verf[1];
			$name = $verf[2];
			$status = $verf[3];

			$whichAction = 0;
			$action = "";
			if( ($status & 2) == 2 ) {
				$whichAction = 1;
				$action = "UPDATE gagged SET status = 20, action = 0, time = 0 WHERE id = $id";
			} else {
				$action = "UPDATE gagged SET status = 32, action = 0 WHERE id = $id";
			}
			if( $approve[$cnt] == "Y" ) {
				mysql_query($action);
				$timestamp = time();
				$logtheaction = "The Lead Admin, $username ($userauth), approved the ";
				if( $whichAction == 1 ) {
					$logtheaction .= "gag ";
				} else {
					$logtheaction .= "ungag ";
				}
				$logtheaction .= "of $name ($steamid).";
				$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '2', '$timestamp', '$userauth', '$username', '$steamid', '$name', '$logtheaction' )";
				mysql_query( $logaction );
			} else {
				if( ($status & 4) == 0 ) {
					mysql_query( "DELETE FROM gagged WHERE id = $id" );
				} else {
					$statusTemp = $status - ($status & 3);
					mysql_query( "UPDATE gagged SET status = $statusTemp WHERE id = $id" );
				}
			}
			$cnt++;
		}
		$this->thankyou( "gag" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class main {
	function main( $p ) {
		$ip = $_SERVER['REMOTE_ADDR'];
		$ver = new verify();
		$html = new default_html( $ip );
		$html->tophalf();
		$pa = new phpadmin( $ver, $ip, $p );
		$html->addcontent( $pa->gettext() );
		$html->bottomhalf();
		$html->printtext();
	}
}
class cat_ads {
	var $text, $id, $ver, $display;
	function cat_ads( $v ) {
		$this->ver = $v;
		$this->text = "";
		$this->display = 20;
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		if( !$this->ver->hasAccess( "FilterReplace" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function add()	{
		$title = "Add an Advertisement";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=ads&sub=form_add' name='addad'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>New Advertisement:</td>
		<td align='left'><input class='forms' type='text' name='advertisement' size='75'></td>
		</tr>
		<tr>
		<td>For Server Config: <select class='forms' name='cfgid'>
		";
		$sqlaction = "SELECT id, name FROM configurations WHERE id != 1";
		$result = mysql_query($sqlaction);
		while( $adrow = mysql_fetch_row($result) ) {
			$id  = $adrow[0];
			$alias = $adrow[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function del() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$totalaction = "SELECT COUNT(*) FROM ads";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		$title = "Find Advertisement To Remove";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=ads&sub=del&id=$prevpos'>Previous $this->display Ads</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=ads&sub=del&id=$nextpos'>Next $this->display Ads</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='60%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT t1.id, t1.advertisement, t2.name FROM ads AS t1, configurations AS t2 WHERE t1.configuration_id  = t2.id ORDER BY t1.id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $adrow = mysql_fetch_row($result) ) {
			$aid = $adrow[0];
			$myad = $adrow[1];
			$configname = $adrow[2];
			$string .= "
			<tr>
			<td align='left'>For Config:<br>$configname</td>
			<td align='right'><a href='index.php?cat=ads&sub=form_del&aid=$aid'>Remove Ad?</a></td>
			</tr>
			<tr>
			<td colspan='2'>$myad</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "
		</table>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_add() {
		$advertisement = trim( $_POST['advertisement'] );
		$cfgid = trim( $_POST['cfgid'] );
		if( empty($advertisement) ) {
			$this->error( "missing" );
			return;
		}
		if( empty($cfgid) ) {
			$this->error( "missing" );
			return;
		}
		mysql_query( "INSERT INTO ads VALUES ( 'LAST_INSERT_ID()+1', '$cfgid', '$advertisement' )" );
		$this->thankyou( "ads" );
	}
	function form_del() {
		$aid = trim( $_REQUEST['aid'] );
		if( empty($aid) ) {
			$this->error( "missing" );
			return;
		}
		mysql_query( "DELETE FROM ads WHERE id = $aid" );
		$this->thankyou( "ads" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_public {
	var $sub, $ver, $pcfg, $display;
	function cat_public( $v, $p ) {
		$this->ver = $v;
		$this->pcfg = $p;
		$this->display = 20;
		$this->sub = "login";
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function login() {
		$string = "";
		if( isset( $_REQUEST['id'] ) ) {
			switch( $_REQUEST['id'] ) {
				case "error":
				$string .= "
				<table align='center' cellpadding='2' cellspacing='1'>
				<tr valign='middle' align='center'>
				<td class='red' colspan='2'>The username/password combination you entered is not valid.</td>
				</tr>
				</table>
				<br>
				";
				break;
				case "selfunban":
				$string .= "
				<table align='center' cellpadding='2' cellspacing='1'>
				<tr valign='middle' align='center'>
				<td class='red' colspan='2'>You have requested yourself to be unbanned.</td>
				</tr>
				</table>
				<br>
				";
				break;
				case "selfreason":
				$string .= "
				<table align='center' cellpadding='2' cellspacing='1'>
				<tr valign='middle' align='center'>
				<td class='red' colspan='2'>You are missing your reason to be unbanned in your request.</td>
				</tr>
				</table>
				<br>
				";
				break;
				case "selfid":
				$string .= "
				<table align='center' cellpadding='2' cellspacing='1'>
				<tr valign='middle' align='center'>
				<td class='red' colspan='2'>You SteamID was not found or is not banned!</td>
				</tr>
				</table>
				<br>
				";
				break;

				case "notactive":
				$string .= "
				<table align='center' cellpadding='2' cellspacing='1'>
				<tr valign='middle' align='center'>
				<td class='red' colspan='2'>Public Unban request is not active!</td>
				</tr>
				</table>
				<br>
				";
				break;
				default:
				//nothing
			}
		}
		$string .= "
		<form action='index.php?cat=public&sub=form_login' method='post'>
		<table class='content' width='70%' align='center' cellspacing='1' cellpadding='2'>
		<tr class='red'>
		<td nowrap colspan='2'>Welcome to PHPAdmin Control Panel.<br>Please login...</td>
		</tr>
		<tr class='red'>
		<td width='50%'>Username:</td>
		<td width='50%'><input type='text' name='username' class='forms'></td>
		</tr>
		<tr class='red'>
		<td width='50%'>Password:</td>
		<td width='50%'><input type='password' name='password' class='forms'></td>
		</tr>
		<tr class='red'>
		<td colspan='2' align='center'><input type='submit' value='Log In' class='forms'></td>
		</tr>
		</table>
		</form>
		<br><br><br><br>
		";
		if( $this->pcfg->getPubUnban() ) {
			$string .= "
			<div align='center' class='titles'>Public Unban Request Form</div>
			<form method='post' action='index.php?cat=public&sub=form_unban' name='unban'>
			<table class='content' width='70%' align='center' cellspacing='1' cellpadding='2'>
			<tr class='red'>
			<td>
			<table align='center' class='text' border='0' cellspacing='0' cellpadding='2'>
			<tr>
			<td width='50%' align='right'>Ban SteamID (STEAM_0:X:XXXXXX):</td>
			<td width='50%' align='left'><input type='text' name='punbansteamid' maxlength='39' size='15' class='forms'></td>
			</tr>
			<tr>
			<td colspan='2'>Reason for Unban:</td>
			</tr>
			<tr>
			<td align='center' colspan='2'><textarea name='punbanreason' wrap='soft' rows='10' cols='75' class='forms'></textarea></td>
			</tr>
			<tr>
			<td align='center' colspan='2'><input type='reset' value='Reset Form' class='forms'> <input type='submit' value='Submit Form' class='forms'></td>
			</tr>
			</table>
			</td>
			</tr>
			</table>
			</form>
	
			<br><br><br><br>
			";
		}
		if( $this->pcfg->getPubList() ) {
			$pos = $_REQUEST['id'];
			if( empty($pos) || $pos < 0 ) {
				$pos = 0;
			}
			$pos = $pos - ($pos % $this->display);
			$totalaction = "SELECT COUNT(*) FROM banned";
			$resultTotal = mysql_query($totalaction);
			$tempTotal = mysql_fetch_row($resultTotal);
			$total = $tempTotal[0];
			if( $total > 0 ) {
	 			$title = "Server Ban List";
				$string .= "
				<div align='center' class='titles'>$title</div>
				<br>
				<div class='text' align='center'>Browse Complete Player Ban List</div>
				<table class='text' width='70%' align='center' border='0' cellspacing='0' cellpadding='0'>
				<tr>
				";
				$prevpos = $pos - $this->display;
				if( $prevpos >= 0 ) {
					$string .= "<td align='left' width='50%'>
					<a href='index.php?cat=public&id=$prevpos'>Previous $this->display Bans</a></td>";
				} else {
					$string .= "<td align='left' width='50%'>&nbsp;</td>";
				}
				$nextpos = $pos + $this->display;
				if( $nextpos < $total ) {
					$string .= "<td align='right' width='50%'>
					<a href='index.php?cat=public&id=$nextpos'>Next $this->display Bans</a></td>";
				} else {
					$string .= "<td align='right' width='50%'>&nbsp;</td>";
				}
				$string .= "
				</tr>
				</table>
				<br>
				<table class='text' width='70%' align='center' border='1' cellspacing='0' cellpadding='0'>
				<tr>
				<td width='15%'><strong><u>Player</strong></u></td>
				<td width='15%'><strong><u>Banned By</strong></u></td>
				<td width='10%'><strong><u>Length (Min.)</strong></u></td>
				<td width='60%'><strong><u>Reason</strong></u></td>
				</tr>
				";
				$action = "SELECT name, time, actionid, reason FROM banned WHERE (status & 4) = 4 ORDER BY id ASC LIMIT $pos, $this->display";
				$result = mysql_query($action);
				while( $findplayer = mysql_fetch_row($result) ) {
					$bannedname = $findplayer[0];
					$bannedtime = $findplayer[1];
					$bannedadmin = $findplayer[2];
					$bannedreason = $findplayer[3];
					$bannedadmin = $this->ver->authid2username($bannedadmin);
					$string .= "
					<tr valign='top'>
					<td>$bannedname</td>
					<td>$bannedadmin</td>
					<td>
					";
					if( $bannedtime != 0 ) {
						$string .= "$bannedtime";
					} else {
						$string .= "Permanent";
					}
					$string .= "
					</td>
					<td>$bannedreason</td>
					</tr>
					";
				}
				$string .= "</table>";
			}
		}
		$this->text = $string;
	}
	function form_unban() {
		if( ! $this->pcfg->getPubUnban() ) {
			header( "Location: index.php?cat=login&id=selfreason" );
			return;
		}
		$punbansteamid = trim( $_POST['punbansteamid'] );
		$punbanreason = trim( htmlspecialchars( $_POST['punbanreason'] ) );
		if( preg_match( "/^(STEAM_0:)[01]{1}[:]{1}[0-9]+$/", $punbansteamid ) == 0 ) {
			header( "Location: index.php?cat=public&sub=login&id=selfid" );
			return;
		}
		if( empty($punbanreason) ) {
			header( "Location: index.php?cat=public&sub=login&id=selfreason" );
			return;
		}
		$actionUnban = "SELECT name, status FROM banned WHERE steamid='$punbansteamid'";
		$getName = mysql_query( $actionUnban );
		if( mysql_num_rows($getName) == 0 ) {
			header( "Location: index.php?cat=public&sub=login&id=selfid" );
			return;
		}
		$getNameRow = mysql_fetch_row($getName);
		$unbanname = $getNameRow[0];
		$unbanstatus = $getNameRow[1];
		$dif = ($unbanstatus & 3);
		$unbanstatus = ($unbanstatus - $dif) | 1;
		$unbanaction = "UPDATE banned SET status = $unbanstatus, reactionid='$punbansteamid', reactreason='$punbanreason' WHERE steamid='$punbansteamid'";
		mysql_query( $unbanaction );
		$timestamp = time();
		$logtheaction = "$unbanname ($punbansteamid) requested himself  to be unbanned because $punbanreason.";
		$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '1', '$timestamp', '$punbansteamid', '$punbansteamid', '$logtheaction' )";
		mysql_query( $logaction );
		header( "Location: index.php?cat=public&sub=login&id=selfunban" );
	}
	function authUserPass( $username, $password ) {
		$action = "SELECT t4.userlevel, t4.weblevel, t2.steamid FROM staff AS t1, steamids AS t2, servers AS t3, usergroups AS t4 WHERE t1.playername = '$username' AND t1.password = '$password' AND t2.staffid = t1.id AND t3.servervalue = 1 AND t3.staffid = t1.id AND t3.usergroupid = t4.id ORDER BY t2.steamid ASC";
		$result = mysql_query( $action );
		if( mysql_num_rows($result) != 0 ) {
			$userinfo = mysql_fetch_row($result);
			$userlevel = $userinfo[0];
			$weblevel = $userinfo[1];
			$steamid = $userinfo[2];
			$_SESSION['username'] = $username;
			$_SESSION['weblevel'] = $weblevel;
			$_SESSION['userlevel'] = $userlevel;
			$_SESSION['steamid'] = $steamid;
			return TRUE;
		}
		return FALSE;
	}
	function form_login() {
		$username = trim( $_POST['username'] );
		$password = trim($_POST['password']);
		if( $this->authUserPass( $username, $password ) ) {
			$string = "
			<meta http-equiv='refresh' content='3; url=index.php?cat=acp'>
			<table class='content' align='center' cellspacing='1' cellpadding='2'>
			<tr class='red'>
			<td align='center'>Thanks for loggin in, $username!
			<br>Now taking you to the PHPAdmin Control Panel...<br><br>
			<a href='index.php?cat=acp'>( Click here if you are not automatically redirected.... )</a>
			</td>
			</tr>
			</table>
			";
			$this->text = $string;
		} else {
			$this->ver->logout();
		}
	}
	function change() {
		if( ! $this->ver->isAuthed() ) {
			$this->error( "access" );
			return;
		}
		$title = "Change My Password";
		$username = $this->ver->getUsername();
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=public&sub=form_change&username=$username' name='change'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td>Admin: $username</td>
		</tr>
		<tr>
		<td>New Password: <input type='text' name='password' maxlength='32' size='32' class='forms'></td>
		</tr>
		<tr>
		<td align='center'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_logout() {
		session_unset();
		header( "Location: index.php" );
	}
	function form_change() {
		if( ! $this->ver->isAuthed() ) {
			$this->error( "access" );
			return;
		}
		$username = trim( $_REQUEST['username'] );
		$password = trim( $_POST['password'] );
		if( empty($password) || empty($username) ) {
			$this->error( "missing" );
			return;
		}
		$action = "UPDATE staff SET password = '$password' WHERE playername = '$username'";
		mysql_query( $action );
		$this->thankyou( "change" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_ban {
	var $text, $display, $ver, $sub, $id;
	function cat_ban( $v ) {
		$this->ver = $v;
		$this->text  = "";
		$this->display = 20;
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		$levelname = "BanMenu";
		if( $this->sub == "banverf" || $this->sub == "form_verf" ) { $levelname = "BanGagManager"; }
		if( !$this->ver->hasAccess( $levelname ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function ban() {
		$username = $this->ver->getUsername();
		$title = "Ban Request Form";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=ban&sub=form_ban' name='ban'>
		<table align='center' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td align='right'>Admin:</td>
		<td align='left'>$username</td>
		</tr>
		<tr>
		<td align='right'>Player Name:</td>
		<td align='left'><input type='text' name='banname' maxlength='32' size='32' class='forms'></td>
		</tr>
		<tr>
		<td align='right'>Ban SteamID:</td>
		<td align='left'><input type='text' name='bansteamid' maxlength='40' size='15' class='forms'></td>
		</tr>
		<tr>
		<td colspan='2' align='left'>Reason:<br><textarea name='banreason' wrap='soft' rows='10' cols='50' class='forms'></textarea></td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$rescount = mysql_query( "SELECT COUNT(*) FROM banned WHERE (status & 12) = 12" );
		$resdata = mysql_fetch_row($rescount);
		$total = $resdata[0];
		if( $total > 0 ) {
			$pos = $this->id;
			if( empty($pos) || $pos < 0 ) { $pos = 0; }
			$pos = $pos - ($pos % $this->display);
			$string .= "
			<br>
			<div class='titles' align='center'>Browse Temporary Ban List</div>
			<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='0'>
			<tr>
			";
			$prevpos = $pos - $this->display;
			if( $prevpos >= 0 ) {
				$string .= "<td align='left' width='50%'>
				<a href='index.php?cat=ban&sub=ban&id=$prevpos'>Previous $this->display Bans</a></td>";
			} else {
				$string .= "<td align='left' width='50%'>&nbsp;</td>";
			}
			$nextpos = $pos + $this->display;
			if( $nextpos < $total ) {
				$string .= "<td align='right' width='50%'>
				<a href='index.php?cat=ban&sub=ban&id=$nextpos'>Next $this->display Bans</a></td>";
			} else {
				$string .= "<td align='right' width='50%'>&nbsp;</td>";
			}
			$string .= "
			</tr>
			</table>
			<br>
			<table class='text' width='60%' align='center' border='0' cellspacing='0' cellpadding='0'>
			<tr>
			<td width='50%'>&nbsp;</td>
			<td width='50%'>&nbsp;</td>
			</tr>
			";
			$action = "SELECT id, steamid, name, time, act, reason FROM banned WHERE (status & 12) = 12 ORDER BY id ASC LIMIT $pos, $this->display";
			$result = mysql_query($action);
			while( $findplayer = mysql_fetch_row($result) ) {
				$bannedid = $findplayer[0];
				$bannedsid = $findplayer[1];
				$bannedname = $findplayer[2];
				$bannedtime = $findplayer[3];
				$bannedadmin = $findplayer[4];
				$bannedreason = $findplayer[5];
				$bannedadmin = $this->ver->authid2username($bannedadmin);
				$string .= "
				<tr>
				<td align='left'>Player: $bannedname</td>
				<td align='right'><a href='index.php?cat=ban&sub=form_pban&pid=$bannedid'>Permanent Ban Player?</a></td>
				</tr>
				<tr>
				<td align='left'>Banned SteamID: $bannedsid</td>
				<td align='right'>Banned By: $bannedadmin</td>
				</tr>
				<tr>
				<td colspan='2'>Temporary Ban Length: $bannedtime Minutes</td>
				</tr>
				<tr>
				<td colspan='2'>Reason for Ban:<br>$bannedreason</td>
				</tr>
				<tr>
				<td colspan='2'>&nbsp;</td>
				</tr>
				";
			}
			$string .= "
			</table>
			<br>
			";
		}
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function searchunban() {
		$search = $_POST['search'];
		$action = "SELECT id, steamid, name, time, actionid, reason FROM banned WHERE (steamid REGEXP '$search' OR name REGEXP '$search') AND (status & 4) = 4 ORDER BY id ASC";
		$result = mysql_query($action);
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "norecords" );
			return;
		}
		$title = "Find Player To Request Unban";
		$string = "
		<div class='titles' align='center'>$title</div>
		<br>
		<form method='post' action='index.php?cat=ban&sub=searchunban' name='search'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Search by SteamID or Name: <input type='text' name='search' class='forms' size='20'></td>
		</tr>
		<tr>
		<td align='right'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		<br>
		<div align='center' class='text'>Player Name or SteamID Matches</div>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td colspan='2' width='100%'>&nbsp;</td>
		</tr>
		";
		while( $findplayer = mysql_fetch_row($result) ) {
			$bannedid = $findplayer[0];
			$bannedsid = $findplayer[1];
			$bannedname = $findplayer[2];
			$bannedtime = $findplayer[3];
			$bannedadmin = $findplayer[4];
			$bannedreason = $findplayer[5];
			$bannedadmin = $this->ver->authid2username($bannedadmin);
			$string .= "
			<tr>
			<td align='left'>Player: $bannedname</td>
			<td align='right'><a href='index.php?cat=ban&sub=unban&id=$bannedid&sid=$bannedsid'>Unban Player?</a></td>
			</tr>
			<tr>
			<td align='left'>Banned SteamID: $bannedsid</td>
			<td align='right'>Banned By: $bannedadmin</td>
			</tr>
			";
			if( $bannedtime != 0 ) {
				$string .= "<tr>
				<td colspan='2'>Temporary Ban Length: $bannedtime</td>
				</tr>";
			}
			$string .= "
			<tr>
			<td colspan='2'>Reason for Ban:<br>$bannedreason</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function preunban() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM banned";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Find Player To Request Unban";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=ban&sub=searchunban' name='search'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Search by SteamID or Name: <input type='text' name='search' class='forms' size='20'></td>
		</tr>
		<tr>
		<td align='right'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		<br>
		<div class='text' align='center'>Browse Complete Player Ban List</div>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=ban&sub=preunban&id=$prevpos'>Previous $this->display Bans</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=ban&sub=preunban&id=$nextpos'>Next $this->display Bans</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT id, steamid, name, time, actionid, reason FROM banned WHERE (status & 4) = 4 ORDER BY id ASC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $findplayer = mysql_fetch_row($result) ) {
			$bannedid = $findplayer[0];
			$bannedsid = $findplayer[1];
			$bannedname = $findplayer[2];
			$bannedtime = $findplayer[3];
			$bannedadmin = $findplayer[4];
			$bannedreason = $findplayer[5];
			$bannedadmin = $this->ver->authid2username($bannedadmin);
			$string .= "
			<tr>
			<td align='left'>Player: $bannedname</td>
			<td align='right'><a href='index.php?cat=ban&sub=unban&id=$bannedid&sid=$bannedsid'>Unban Player?</a></td>
			</tr>
			<tr>
			<td align='left'>Banned SteamID: $bannedsid</td>
			<td align='right'>Banned By: $bannedadmin</td>
			</tr>
			";
			if( $bannedtime != 0 ) {
				$string .= "<tr>
				<td colspan='2'>Temporary Ban Length: $bannedtime</td>
				</tr>";
			}
			$string .= "
			<tr>
			<td colspan='2'>Reason for Ban:<br>$bannedreason</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function unban() {
		if( empty($this->id) ) {
			$this->error( "invalidid" );
			return;
		}
		$sid = $_POST['sid'];
		$string = $this->text;
		$username = $this->ver->getUsername();
		$title = "Unban Request Form";
		$string = "
		<div align='center' class='text'>$title</div>
		<br>
		<form method='post' action='index.php?cat=ban&sub=form_unban&unbanid=$this->id' name='unban'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='2'>
		<tr>
		<td>Admin: $username</td>
		</tr>
		<tr>
		<td>Unban SteamID: $sid</td>
		</tr>
		<tr>
		<td>Reason for Unban:<br><textarea name='unbanreason' wrap='soft' rows='10' cols='50' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='center'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
 	function verify() {
		$string = $this->text;
		$action = "SELECT id, steamid, name, actionid, reactionid, reason, reactreason, status FROM banned WHERE (status & 3) != 0 ORDER BY id ASC";
		$result = mysql_query($action);
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "verify" );
			return;
		}
		$title = "Verify Ban/Unban Requests Form";
		$string .= "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=ban&sub=form_verf' name='banverf'>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		";
 		while( $request = mysql_fetch_row($result) ) {
			$id = $request[0];
			$steamid = $request[1];
			$name = $request[2];
			$banadmin = $request[3];
			$unbanadmin = $request[4];
			$banreason = $request[5];
			$unbanreason = $request[6];
			$status = $request[7];
			$banadmin = $this->ver->authid2username($banadmin);
			$unbanadmin = $this->ver->authid2username($unbanadmin);
			$statusStr = "";
			if( ($status & 2) == 2 ) {
				$statusStr = "Ban";
				$adminname = $banadmin;
			} else {
				$statusStr = "Unban";
				$adminname = $unbanadmin;
			}
			$arrayFindthis = array( "^\t^" );
			$arraySubwith = array( "<br>" );
			$name = preg_replace( $arrayFindthis, $arraySubwith, $name );
			$string .= "
			<tr>
			<td align='left' width='50%'><strong>Ban-ee:</strong> $name / $steamid</td>
			<td align='right' width='50%'><strong>Requesting Admin:</strong> $adminname</td>
			</tr>
			<tr>
			<td colspan='2' width='100%'><strong>Ban Reason:</strong><br>$banreason</td>
			</tr>
			";
 			if( ($status & 1) == 1 ) {
				$string .= "
				<tr>
				<td colspan='2'><strong>Unban Reason:</strong><br>$unbanreason</td>
				</tr>
				";
			}
			$string .= "
			<tr>
			<td colspan='2'><strong>Approve $statusStr?:</strong>
			<select class='forms' name='approve[]'>
			<option>Y</option>
			<option selected>N</option>
			</select>
			</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "
		<tr>
		<td align='center' colspan='2'><input type='submit' value='Submit Form' class='forms'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function log() {
		$pos = $this->id;
		if( empty($pos) || !is_numeric($pos) ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM logged WHERE type = 1";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Viewing Admin Logs";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr width='100%'>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=ban&sub=log&id=$prevpos'>Previous $this->display Log Actions</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=ban&sub=log&id=$nextpos'>Next $this->display Log Actions</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT timestamp, actionid, action FROM logged WHERE type = 1 ORDER BY timestamp DESC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $getlog = mysql_fetch_row($result) ) {
			$timestamp = $getlog[0];
			$sid = $getlog[1];
			$logaction = $getlog[2];
			$adminname = $this->ver->authid2username( $sid );
			$dateformatted = date( "l F j, Y", $timestamp  );
			$string .= "
			<tr>
			<td align='left'>Date: $dateformatted</td>
			<td align='right'>Admin: $adminname</td>
			</tr>
			<tr>
			<td colspan='2'>Action Performed:<br>$logaction</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "
		</table>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_ban() {
		$banname = trim( htmlspecialchars($_POST['banname'] ) );
		$bansteamid = trim( $_POST['bansteamid'] );
		$banreason = trim( htmlspecialchars( $_POST['banreason'] ) );
		if( preg_match( "/^(STEAM_0:)[01]{1}[:]{1}[0-9]+$/", $bansteamid ) == 0 ) {
			$this->error( "steamid" );
			return;
		}
		if( empty($banname) || empty($banreason) ) {
			$this->error( "missing" );
			return;
		}
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$level = $this->ver->hasAccess( "BanGagManager" );
		$userTempBanned = "SELECT status FROM banned WHERE steamid='$bansteamid'";
		$resultTemp = mysql_query($userTempBanned);
		if( mysql_num_rows($resultTemp) != 0 ) {
			$this->error( "duplicate" );
			return;
		}
		$timestamp = time();
		$addAction = "INSERT INTO banned VALUES ( 'LAST_INSERT_ID()+1', '$bansteamid', '$banname', '$timestamp', '0', '";
		if( $level ) {
			$addAction .= "20";
		} else {
			$addAction .= "18";
		}
		$addAction .= "', '1', '0', '$userauth', '0', '$banreason', 'NA' )";
		mysql_query( $addAction );
		$logtheaction = "$username ($userauth) ";
		if( $level ) {
			$logtheaction .= "banned ";
		} else {
			$logtheaction .= "requested a permanent ban ";
		}
		$logtheaction .= "on $banname ($bansteamid) because $banreason.";
		$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '1', '$timestamp', '$userauth', '$username', '$bansteamid', '$banname', '$logtheaction' )";
		mysql_query( $logaction );
		$this->thankyou( "ban" );
	}
	function form_pban() {
		$pid = 0;
		if( isset( $_REQUEST['pid'] ) ) { $pid = $_REQUEST['pid']; }
		$userTempBanned = "SELECT steamid, name, reason FROM banned WHERE id = $pid";
		$resultTemp = mysql_query($userTempBanned);
		if( mysql_num_rows($resultTemp) == 0 ) {
			$this->error( "norecords" );
			return;
		}
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$level = $this->ver->hasAccess( "BanGagManager" );
		$rows = mysql_fetch_row($resultTemp);
		$bansteamid = $rows[0];
		$banname = $rows[1];
		$banreason = $rows[2];
		$actionPBan = "";
		if( $level ) {
			$actionPBan = "UPDATE banned SET status = 20, time = 0, action = 0 WHERE id = $pid";
		} else {
			$actionPBan = "UPDATE banned SET status = 14, action = 0 WHERE id = $pid";
		}
		mysql_query($actionPBan);
		$timestamp = time();
		$logtheaction = "$username ($userauth) ";
		if( $level ) {
			$logtheaction .= "banned ";
		} else {
			$logtheaction .= "requested a permanent ban";
		}
		$logtheaction .= "on $banname ($bansteamid) because $banreason.";
		$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '1', '$timestamp', '$userauth', '$username', '$bansteamid', '$banname', '$logtheaction' )";
		mysql_query( $logaction );
		$this->thankyou( "ban" );
	}
	function form_unban() {
		if( isset( $_REQUEST['unbanid'] ) ) { $unbanid = $_REQUEST['unbanid']; }
		$unbanreason = trim( htmlspecialchars( $_POST['unbanreason'] ) );
		$actionName = "SELECT steamid, name, status FROM banned WHERE id = $unbanid";
		$getName = mysql_query( $actionName );
		if( mysql_num_rows($getName) == 0 ) {
			$this->error( "norecords" );
			return;
		}
		if( empty($unbanreason) ) {
			$this->error( "missing" );
			return;
		}
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$level = $this->ver->hasAccess( "BanGagManager" );
		$getNameRow = mysql_fetch_row($getName);
		$unbansteamid = $getNameRow[0];
		$unbanname = $getNameRow[1];
		$unbanstatus = $getNameRow[2];
		$unbanaction = "UPDATE banned SET ";
		if( $level ) {
			$unbanaction .= "status = 32, action = 0, ";
		} else {
			$dif = ($unbanstatus & 3);
			$unbanstatus = ($unbanstatus - $dif) | 1;
			$unbanaction .= "status = $unbanstatus, ";
		}
		$unbanaction .= "reactionid='$userauth', reactreason='$unbanreason' WHERE id = $unbanid";
		mysql_query( $unbanaction );
		$timestamp = time();
		$logtheaction = "$username ($userauth) ";
		if( $level ) {
			$logtheaction .= "unbanned ";
		} else {
			$logtheaction .= "requested to unban ";
		}
		$logtheaction .= "$unbanname ($unbansteamid) because $unbanreason.";
		$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '1', '$timestamp', '$userauth', '$username', '$unbansteamid', '$unbanname', '$logtheaction' )";
		mysql_query( $logaction );
		$this->thankyou( "ban" );
	}
	function form_verf() {
		$approve = $_POST['approve'];
		$username = $this->ver->getUsername();
		$userauth = $this->ver->getSteamID();
		$verfaction = "SELECT id, steamid, name, status FROM banned WHERE (status & 3) != 0 ORDER BY id ASC";
		$verfresult = mysql_query($verfaction);
		$cnt = 0;
		while( $verf = mysql_fetch_row($verfresult) ) {
			$id = $verf[0];
			$steamid = $verf[1];
			$name = $verf[2];
			$status = $verf[3];
			$whichAction = 0;
			$action = "";
			if( ($status & 2) == 2 ) {
				$whichAction = 1;
				$action = "UPDATE banned SET status = 20, action = 0 WHERE id = $id";
			} else {
				$action = "UPDATE banned SET status = 32, action = 0 WHERE id = $id";
			}
			if( $approve[$cnt] == "Y" ) {
				mysql_query($action);
				$timestamp = time();
				$logtheaction = "The Lead Admin, $username ($userauth), approved the ";
				if( $whichAction == 1 ) {
					$logtheaction .= "ban ";
				} else {
					$logtheaction .= "unban ";
				}
				$logtheaction .= "of $name ($steamid).";
				$logaction = "INSERT INTO logged VALUES ( 'LAST_INSERT_ID()+1', '1', '$timestamp', '$userauth', '$username', '$steamid', '$name', '$logtheaction' )";
				mysql_query( $logaction );
			} else {
				if( ($status & 4) == 0 ) {
					mysql_query( "DELETE FROM banned WHERE id = $id" );
				} else {
					$statusTemp = $status - ($status & 3);
					mysql_query( "UPDATE banned SET status = $statusTemp WHERE id = $id" );
				}
			}
			$cnt++;
		}
		$this->thankyou( "ban" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class verify {
	var $username, $weblevel, $userlevel, $steamid, $authed, $access;
	function verify() {
		$this->username = "";
		$this->steamid =  "";
		$this->weblevel = 0;
		$this->userlevel = 0;
		$this->authed = FALSE;
		$this->access = array(
			"GagMenu" => 1,
			"BanMenu" => 1,
			"LogMenu" => 2,
			"RestrictManager" => 4,
			"Character" => 8,
			"FilterReplace" => 16,
			"BanGagManager" => 32,
			"UserManager" => 64,
			"Config" => 128
		);
		if( isset($_SESSION['username']) ) {
			$this->username = $_SESSION['username'];
			$this->weblevel = $_SESSION['weblevel'];
			$this->userlevel = (int) $_SESSION['userlevel'];
			$this->steamid = $_SESSION['steamid'];
			$this->authed = TRUE;
		}
	}
	function getAccessLevels() { return $this->access; }
	function hasAccess( $level ) {
		$req = (int) $this->access[$level];
		$web = (int) $this->weblevel;
		return ($web & $req) == $req;
	}
	function authid2username( $steamid ) {
		$action = "SELECT t1.playername FROM staff AS t1, steamids AS t2 WHERE t2.staffid = t1.id AND t2.steamid = '$steamid'";
		$result = mysql_query( $action );
		$userinfo = mysql_fetch_row($result);
		$uname = $userinfo[0];
		if( empty($uname) ) {
			$uname = "Admin/Self";
		}
		return $uname;
	}
	function logout() {
		session_unset();
		header( "Location: index.php" );
	}
	function isAuthed() { return $this->authed; }
	function getSteamID() { return $this->steamid; }
	function getWeblevel() { return $this->weblevel; }
	function getUserlevel() { return $this->userlevel; }
	function getUsername() { return $this->username; }
}
class ty {
	var $text, $ver;
	function ty( $v ) {
		$this->ver = $v;
		$this->text = "";
	}
	function whichty( $ty ) {
		$content = "";
		switch( $ty ) {
			case "ads":
			$content = "<div align='center' class='titles'>Advertisement Requests have Been Processed!</div>";
			break;
			case "ban":
			$content = "<div align='center' class='titles'>Ban/Unban Requests have Been Processed!</div>";
			break;
			case "character":
			$content = "<div align='center' class='titles'>\"Llama\" Character has been ADDED/EDITED/DELETED!</div>";
			break;
			case "filter":
			$content = "<div align='center' class='titles'>Filter has been ADDED/DELETED!</div>";
			break;
			case "gag":
			$content = "<div align='center' class='titles'>Gag/Ungag Requests have Been Processed!</div>";
			break;
			case "log":
			$content = "<div align='center' class='titles'>The Report Request has been set to Handled!</div>";
			break;
			case "tagip":
			$content = "<div align='center' class='titles'>A Restricted IP/Tag Request Has Been Processed!</div>";
			break;
			case "reveal":
			$content = "<div align='center' class='titles'>A Revealed SteamID Has Been Processed!</div>";
			break;
			case "cfg":
			$content = "<div align='center' class='titles'>Server CFG File ADDED/SET/DELETED!</div>";
			break;
			case "uploadmap":
			$content = "<div align='center' class='titles'>The MAP has been Uploaded!</div>";
			break;
			case "mapcycle":
			$content = "<div align='center' class='titles'>Mapcycle has been changed!</div>";
			break;
			case "member":
			$content = "<div align='center' class='titles'>Admin has been Added/Deleted!</div>";
			break;
			case "group":
			$content = "<div align='center' class='titles'>The UserGroup was Added/Edited/Deleted!</div>";
			break;
			case "change":
			$content = "<div align='center' class='titles'>Your password has been changed!</div>";
			break;
			default:
			$content = "<div align='center' class='titles'>Thank You for submitting your form!</div>";
		}
		$content = "<br><br>$content<br><br>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $content );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function gettext() { return $this->text; }
}
class phpadmin {
	var $text, $cat, $ip, $ver, $pcfg;
	function phpadmin( $v, $i, $p ) {
		$this->text = "";
		$this->ip = $i;
		$this->ver = $v;
		$this->pcfg = $p;
		if( isset( $_REQUEST['cat'] ) ) { $this->cat = $_REQUEST['cat']; }
		$this->cat = "cat_public";
		if( isset( $_REQUEST['cat'] ) ) { $this->cat = "cat_" . $_REQUEST['cat']; }
		if( !method_exists( $this, $this->cat ) ) {
			$this->cat = "cat_public";
			$this->error( "catcode" );
			return;
		}
		call_user_func( array(&$this,$this->cat) );
	}
	function cat_acp() {
		if( !$this->ver->isAuthed() ) {
			$this->ver->logout();
			return;
		}
		$username = $this->ver->getUsername();
		$string = "
		<table align='center' cellpadding='2' cellspacing='1'>
		<tr valign='middle'>
		<td class='text'>Welcome, $username, to the PHPAdmin Control Panel. All options available to you are on the left menu bar.</td>
		</tr>
		</table>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function cat_public() {
		$cp = new cat_public( $this->ver, $this->pcfg );
		$this->text = $cp->gettext();
	}
	function cat_ads() {
		$ca = new cat_ads( $this->ver );
		$this->text = $ca->gettext();
	}
	function cat_ban() {
		$cb = new cat_ban( $this->ver );
		$this->text = $cb->gettext();
	}
	function cat_gag() {
		$cg = new cat_gag( $this->ver );
		$this->text = $cg->gettext();
	}
	function cat_users() {
		$cu = new cat_users( $this->ver, $this->pcfg );
		$this->text = $cu->gettext();
	}
	function cat_characters() {
		$cc = new cat_characters( $this->ver );
		$this->text = $cc->gettext();
	}
	function cat_filter() {
		$cf = new cat_filter( $this->ver );
		$this->text = $cf->gettext();
	}
	function cat_log() {
		$cl = new cat_log( $this->ver );
		$this->text = $cl->gettext();
	}
	function cat_restrict() {
		$cr = new cat_restrict( $this->ver );
		$this->text = $cr->gettext();
	}
	function cat_servercfg() {
		$csc = new cat_servercfg( $this->ver, $this->pcfg );
		$this->text = $csc->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function ty( $thankyou ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thankyou );
		$this->text = $ty->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_characters {
	var $text, $cat, $ver;
	function cat_characters( $v ) {
		$this->ver = $v;
		$this->text = "";
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		if( !$this->ver->hasAccess( "Character" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function add() {
		$title = "Add New \"Llama\" Character";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=characters&sub=form_add' name='add'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Character*:</td>
		<td align='left'><input class='forms' type='text' name='addcharname' size='15' maxlength='50'></td>
		</tr>
		<tr>
		<td align='right'>Saying 1*:</td>
		<td align='left'><input class='forms' type='text' name='addsay1' size='10' maxlength='50'></td>
		</tr>
		<tr>
		<td align='right'>Saying 2:</td>
		<td align='left'><input class='forms' type='text' name='addsay2' size='10' maxlength='50'></td>
		</tr>
		<tr>
		<td align='right'>Saying 3:</td>
		<td align='left'><input class='forms' type='text' name='addsay3' size='10' maxlength='50'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'>* = means required field.</td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function preedit() {
		$action = "SELECT id, animal FROM animals ORDER BY id ASC";
		$result = mysql_query($action);
		$title = "Edit \"Llama\" Character";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=characters&sub=edit' name='preeditchar'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Character Name: <select class='forms' name='editid'>
		";
		while( $data = mysql_fetch_row($result) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function edit() {
		$editid = $_POST['editid'];
		$action = "SELECT * FROM animals WHERE id = $editid";
		$result = mysql_query($action);
		$charinfo = mysql_fetch_row($result);
		//$id = $charinfo[0];
		$animal = $charinfo[1];
		$count = $charinfo[2];
		$say1 = $charinfo[3];
		$say2 = $charinfo[4];
		$say3 = $charinfo[5];
		$title = "Edit \"Llama\" Character";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=characters&sub=form_edit&charid=$editid' name='editchar'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Character*:</td>
		<td align='left'>$animal</td>
		</tr>
		<tr>
		<td align='right'>Saying 1*:</td>
		<td align='left'><input class='forms' type='text' name='editsay1' size='10' maxlength='50' value='$say1'></td>
		</tr>
		<tr>
		<td align='right'>Saying 2 (if empty leave NONE):</td>
		<td align='left'><input class='forms' type='text' name='editsay2' size='10' maxlength='50' value='$say2'></td>
		</tr>
		<tr>
		<td align='right'>Saying 3 (if empty leave NONE):</td>
		<td align='left'><input class='forms' type='text' name='editsay3' size='10' maxlength='50' value='$say3'></td>
		</tr>
		<tr>
		<td colspan='2' align='center'>* = means required field.</td>
		</tr>
		<tr>
		<td colspan='2' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function del() {
		$action = "SELECT id, animal FROM animals ORDER BY id ASC";
		$result = mysql_query($action);
		$title = "Delete \"Llama\" Character";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=characters&sub=form_del' name='delchar'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td align='right'>Character: <select class='forms' name='delcharid'>
		";
		while( $data = mysql_fetch_row($result) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_add() {
		$addcharname = trim( $_POST['addcharname'] );
		$say1 = trim( $_POST['addsay1'] );
		$say2 = trim( $_POST['addsay2'] );
		$say3 = trim( $_POST['addsay3'] );
		if( empty($addcharname) || empty($say1) ) {
			$this->error( "missing" );
			return;
		}
		$cnt = 1;
		if( empty($say2) ) {
			$say2 = "NONE";
		} else {
			$cnt++;
		}
		if( empty($say3) ) {
			$say3 = "NONE";
		} else {
			$cnt++;
		}
		mysql_query( "INSERT INTO animals VALUES ( 'LAST_INSERT_ID()+1', '$addcharname', '$cnt', '$say1', '$say2', '$say3' )" );
		$this->thankyou( "character" );
	}
	function form_edit() {
		$charid = trim( $_REQUEST['charid'] );
		$say1 = trim( $_POST['editsay1'] );
		$say2 = trim( $_POST['editsay2'] );
		$say3 = trim( $_POST['editsay3'] );
		if( empty($charid) || empty($say1) ) {
			$this->error( "missing" );
			return;
		}
		$cnt = 1;
		if( empty($say2) || strcasecmp($say2, "NONE") == 0 ) {
			$say2 = "NONE";
		} else {
			$cnt++;
		}
		if( empty($say3) || strcasecmp($say3, "NONE") == 0 ) {
			$say3 = "NONE";
		} else {
			$cnt++;
		}
		mysql_query( "UPDATE animals SET count = $cnt, say1='$say1', say2='$say2', say3='$say3' WHERE id = $charid" );
		$this->thankyou( "character" );
	}
	function form_del() {
		$delcharid = trim( $_POST['delcharid'] );
		if( empty($delcharid) ) {
			$this->error( "missing" );
			return;
		}
		mysql_query( "DELETE FROM animals WHERE id = $delcharid" );
		$this->thankyou( "character" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class shell {
	var $text, $ver;
	function shell( $v ) {
		$this->text = "";
		$this->ver = $v;
	}
	function topstatic() {
		$string = $this->text;
		$username = $this->ver->getUsername();
		$string = "
		<table class='content' align='center'>
		<tr valign='middle' align='center'>
		<td class='header' colspan='2'>PHPAdmin Control Panel</td>
		</tr>
		<tr valign='top'>
		<td class='pad' width='25%'>
		<table class='text' width='100%' align='center' border='0' cellpadding='2' cellspacing='1'>
		";
		if( $this->ver->hasAccess( "BanMenu" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Ban/Unban Administration</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=ban&sub=ban'>Request a Ban</a><br>
			&raquo; <a href='index.php?cat=ban&sub=preunban'>Request an Unban</a><br>
			&raquo; <a href='index.php?cat=ban&sub=log'>View Action Logs</a><br>
			";
		}
		if( $this->ver->hasAccess( "BanGagManager" ) ) {
			$string .= "
			&raquo; <a href='index.php?cat=ban&sub=verify'>View Ban Action Requests</a><br>
			";
		}
		if( $this->ver->hasAccess( "BanMenu" ) || $this->ver->hasAccess( "BanGagManager" ) ) {
			$string .= "
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "BanMenu" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Gag/Ungag Administration</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=gag&sub=gag'>Request a Gag</a><br>
			&raquo; <a href='index.php?cat=gag&sub=preungag'>Request an Ungag</a><br>
			&raquo; <a href='index.php?cat=gag&sub=log'>View Gag Action Logs</a><br>
			";
		}
		if( $this->ver->hasAccess( "BanGagManager" ) ) {
			$string .= "
			&raquo; <a href='index.php?cat=gag&sub=verify'>View Gag Action Requests</a><br>
			";
		}
		if( $this->ver->hasAccess( "GagMenu" ) || $this->ver->hasAccess( "BanGagManager" ) ) {
			$string .= "
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "FilterReplace" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Ads Menu</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=ads&sub=add'>Add Advertisement</a><br>
			&raquo; <a href='index.php?cat=ads&sub=del'>Delete Advertisement</a><br>
			</td>
			</tr>
			<tr valign='middle'>
			<td class='header'>Filter/Replace Menu</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=filter&sub=add'>Add Filter/Replace</a><br>
			&raquo; <a href='index.php?cat=filter&sub=del'>Delete Filter/Replace</a><br>
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "Character" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>\"Llama\" Character</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=characters&sub=add'>Add Character</a><br>
			&raquo; <a href='index.php?cat=characters&sub=preedit'>Edit Character</a><br>
			&raquo; <a href='index.php?cat=characters&sub=del'>Delete Character</a><br>
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "LogMenu" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Logging Administration</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=log&sub=pending'>View Uncomp. Report</a><br>
			&raquo; <a href='index.php?cat=log&sub=handled'>View Comp. Report</a><br>
			&raquo; <a href='index.php?cat=log&sub=kick'>View Kick Logs</a><br>
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "RestrictManager" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Flagged IP/Tag Section</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=restrict&sub=addtag'>Add Restricted Tag</a><br>
			&raquo; <a href='index.php?cat=restrict&sub=deltag'>Delete Restricted Tag</a><br>
			&raquo; <a href='index.php?cat=restrict&sub=addip'>Add Restricted IP</a><br>
			&raquo; <a href='index.php?cat=restrict&sub=delip'>Delete Restricted IP</a><br>
			&raquo; <a href='index.php?cat=restrict&sub=addreveal'>Add Reveal</a><br>
			&raquo; <a href='index.php?cat=restrict&sub=delreveal'>Delete Reveal</a><br>
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "Config" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Server Configs</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=servercfg&sub=add'>Add Config</a><br>
			&raquo; <a href='index.php?cat=servercfg&sub=preedit'>Edit Configs</a><br>
			&raquo; <a href='index.php?cat=servercfg&sub=copy'>Copy Config</a><br>
			&raquo; <a href='index.php?cat=servercfg&sub=del'>Delete Config</a><br>
			&raquo; <a href='index.php?cat=servercfg&sub=precycle'>Mapcycle</a><br>
			&raquo; <a href='index.php?cat=servercfg&sub=upload'>Upload Maps</a><br>
			</td>
			</tr>
			";
		}
		if( $this->ver->hasAccess( "UserManager" ) ) {
			$string .= "
			<tr valign='middle'>
			<td class='header'>Add/Delete Admins</td>
			</tr>
			<tr valign='middle'>
			<td>
			&raquo; <a href='index.php?cat=users&sub=add'>Add Admin</a><br>
			&raquo; <a href='index.php?cat=users&sub=preedit'>Edit Admin</a><br>
			&raquo; <a href='index.php?cat=users&sub=del'>Delete Admin</a><br>
			&raquo; <a href='index.php?cat=users&sub=gadd'>Add UserGroup</a><br>
			&raquo; <a href='index.php?cat=users&sub=gpreedit'>Edit UserGroup</a><br>
			&raquo; <a href='index.php?cat=users&sub=gdel'>Delete UserGroup</a><br>
			</td>
			</tr>
			";
		}
		$string .= "
		<tr valign='middle'>
		<td>Logged in as $username<br>
		&raquo; <a href='index.php?cat=public&sub=change'>Change My Password</a><br>
		&raquo; <a href='index.php?cat=public&sub=form_logout'>Log Out</a></td>
		</tr>
		</table>
		</td>
		<td class='pad' width='75%'>
		<table class='text' width='100%' align='center' cellpadding='2' cellspacing='1'>
		<tr valign='middle'>
		<td>
		";
		$this->text = $string;
	}
	function addcontent( $content ) { $this->text .= $content; }
	function bottomstatic() {
		$string = $this->text;
		$string .= "
		</td>
		</tr>
		</table>
		</td>
		</tr>
		</table>
		";
		$this->text = $string;
	}
	function gettext() { return $this->text; }
}
class cat_servercfg {
	var $text, $id, $ver, $pcfg;
	function cat_servercfg( $v, $p ) {
		$this->ver = $v;
		$this->pcfg = $p;
		$this->text = "";
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		if( !$this->ver->hasAccess( "Config" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function add() {
		$title = "Add New Server CFG";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=form_add' name='add'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>CFG Name: <input class='forms' type='text' name='addcfgname' size='15' maxlength='50'></td>
		</tr>
		<tr>
		<td>Settings:<br><textarea name='addcfg' wrap='soft' rows='40' cols='90' class='forms'></textarea></td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function preedit() {
		$action = "SELECT id, name FROM configurations WHERE id != 1 ORDER BY id ASC";
		$result = mysql_query($action);
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "noeditdel" );
			return;
		}
		$title = "Edit Server CFG";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=edit' name='edit'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Server CFG Name: <select class='forms' name='cfgid'>";
		while( $data = mysql_fetch_row($result) ) {
			$id  = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function edit() {
		$cfgid = $_POST['cfgid'];
		$action = "SELECT name, config, server FROM configurations WHERE id = $cfgid";
		$result = mysql_query($action);
		$cfginfo = mysql_fetch_row($result);
		$name = $cfginfo[0];
		$mycfg = $cfginfo[1];
		$server = $cfginfo[2];
		$title = "Edit Server CFG";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=form_edit&cfgid=$cfgid' name='edit'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>CFG Name: $name</td>
		</tr>
		<tr>
		<td>Settings: <br><textarea name='editcfg' wrap='soft' rows='40' cols='90' class='forms'>$mycfg</textarea></td>
		</tr>
		<tr>
		<td>&nbsp;</td>
		</tr>
		<tr>
		<td align='center'>Set As Working Server.cfg on Which Servers</td>
		</tr>
		<tr>
		<td align='center'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		";
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$servervalue = pow( 2, $i );
			$name = $this->pcfg->getServerAt($i);
			$string .= "
			<tr>
			<td align='right'>$name:</td>
			<td align='left'><select class='forms' name='activate[]'>
			<option>N</option>
			<option";
			if( ($server & $servervalue) != 0 ) { $string .= " selected"; }
			$string .= ">Y</option>
			</select>
			</td>
			</tr>
			";
		}
		$string .= "
		</table>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function copy() {
		$action = "SELECT id, name FROM configurations ORDER BY id ASC";
		$result = mysql_query($action);
		$title = "Copy a CFG";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=form_copy' name='copy'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>CFG to Copy: <select class='forms' name='oldcfgid'>
		";
		while( $data = mysql_fetch_row($result) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td>New CFG Name: <input class='forms' type='text' name='newcfgname' size='15' maxlength='50'></td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function del() {
		$action = "SELECT id, name FROM configurations WHERE id != 1 AND server = 0";
		$result = mysql_query($action);
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "noeditdel" );
			return;
		}
		$title = "Delete CFG Setting";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=form_del' name='del'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>CFG Name: <select class='forms' name='delcfgid'>
		";
		while( $data = mysql_fetch_row($result) ) {
			$id = $data[0];
			$alias = $data[1];
			$string .= "<option value='$id'>$alias</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function precycle() {
		$title = "Edit MapCycle";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=mapcycle' name='precycle'>
		<table align='center' class='text' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Server CFG Name: <select class='forms' name='cfgid'>";
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$sname = $this->pcfg->getServerAt($i);
			$string .= "<option value='$i'>$sname</option>";
		}
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function mapcycle() {
		$cfgid = $_REQUEST['cfgid'];
		$title = "Change Mapcycle";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' action='index.php?cat=servercfg&sub=form_mapcycle&cfgid=$cfgid' name='mapcycle'>
		<table width='60%' class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr valign='top'>
		<td width='40%'><strong>Mapcycle:</strong><div align='center'><textarea name='mapcycle' wrap='soft' rows='35' cols='30' class='forms'>";
		$lines = file( $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/mapcycle.txt" );
		for( $i = 0; $i < count($lines); $i++ ) {
			$line = $lines[$i];
			$string .= $line;
		}
		$string .= "</textarea></div></td>
		<td width='10%' align='center'>&nbsp;</td>
		<td width='40%' align='center'><strong>Available Maps</strong><br>";
		$diary_directory = opendir( $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/maps/" );
		while( $filename = readdir($diary_directory) ) {
			$lastcnt = strrpos( $filename, "." );
			$fileextension = substr( $filename, ($lastcnt + 1) );
			if( strcasecmp( $fileextension, "bsp" ) == 0 ) {
				$filename = str_replace( ".bsp", "", $filename );
				$string .= "$filename<br>";
			}
		}
		closedir($diary_directory);
		$string .= "
		</td>
		</tr>
		<tr>
		<td colspan='3' align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();

		$this->text = $s->gettext();
	}
	function upload() {
		$title = "Upload Maps";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<form method='post' enctype='multipart/form-data' action='index.php?cat=servercfg&sub=form_upload' name='uploadmaps'>
		<table class='text' align='center' border='0' cellspacing='0' cellpadding='5'>
		<tr>
		<td>Map to Upload (BSP Format):<br><input type='file' name='bsp' size='40' class='forms'></td>
		</tr>
		<tr>
		<td>Map Description (TXT Format):<br><input type='file' name='txt' size='40' class='forms'></td>
		</tr>
		<tr>
		<td>Server CFG Name: <select class='forms' name='cfgid'>";
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$alias = $this->pcfg->getServerAt($i);
			$string .= "<option value='$i'>$alias</option>";
		}
		if( $this->pcfg->getServerCount() != 1 ) { $string .= "<option value='100'>All Servers</option>"; }
		$string .= "
		</select>
		</td>
		</tr>
		<tr>
		<td align='center'><input class='forms' type='submit' value='Submit Form'></td>
		</tr>
		</table>
		</form>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_add() {
		$addcfgname = trim( $_POST['addcfgname'] );
		$addcfg = trim( $_POST['addcfg'] );
		if( empty($addcfgname) || empty($addcfg) ) {
			$this->error( "missing" );
			return;
		}
		mysql_query( "INSERT INTO configurations VALUES ( 'LAST_INSERT_ID()+1', '$addcfgname', '0', '$addcfg' )" );
		$this->thankyou( "cfg" );
	}
	function form_edit() {
		$cfgid = trim( $_REQUEST['cfgid'] );
		$editcfg = trim( $_POST['editcfg'] );
		$activate = $_POST['activate'];
		if( empty($cfgid) || empty($editcfg) ) {
			$this->error( "missing" );
			return;
		}
		$status = 0;
		for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
			$act = $activate[$i];
			if( !strcasecmp( $act, "Y" ) ) {
				$status = $status | pow( 2, $i );
			}
		}
		$action = "UPDATE configurations SET server = $status, config='$editcfg' WHERE id = $cfgid";
		mysql_query( $action );
		$this->thankyou( "cfg" );
	}
	function form_copy() {
		$oldcfgid = trim( $_POST['oldcfgid'] );
		$newcfgname = trim( $_POST['newcfgname'] );
		if( empty($oldcfgid) || empty($newcfgname) ) {
			$this->error( "missing" );
			return;
		}
		$result = mysql_query( "SELECT config FROM configurations WHERE id = $oldcfgid" );
		if( mysql_num_rows($result) == 0 ) {
			$this->error( "missing" );
			return;
		}
		$rows = mysql_fetch_row( $result );
		$cfg = $rows[0];
		mysql_query( "INSERT INTO configurations VALUES ( 'LAST_INSERT_ID()+1', '$newcfgname', '0', '$cfg' )" );
		$this->thankyou( "cfg" );
	}
	function form_del() {
		$delcfgid = trim( $_POST['delcfgid'] );
		if( empty($delcfgid) ) {
			$this->error( "missing" );
			return;
		}
		mysql_query( "DELETE FROM configurations WHERE id = $delcfgid AND id != 1 AND server = 0" );
		$this->thankyou( "cfg" );
	}
	function form_upload() {
		$cfgid = $_POST['cfgid'];
		$lastcnt = strrpos( $_FILES['bsp']['name'], "." );
		$fileextension = substr( $_FILES['bsp']['name'], ($lastcnt + 1) );
		if( strcasecmp( $fileextension, "bsp" ) != 0 ) {
			$this->error( "filename" );
			return;
		}
		$hastext = FALSE;
		if( !empty($_FILES['txt']['name']) ) {
			$lastcnt = strrpos( $_FILES['txt']['name'], "." );
			$fileextension = substr( $_FILES['txt']['name'], ($lastcnt + 1) );
			if( strcasecmp( $fileextension, "txt" ) != 0 ) {
				$this->error( "filename" );
				return;
			}
			$descname = basename($_FILES['txt']['name']);
			if( move_uploaded_file( $_FILES['txt']['tmp_name'], $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/maps/$descname" ) ) {
				$hastext = TRUE;
			}
		}
		$bspname = basename($_FILES['bsp']['name']);
		if( !move_uploaded_file( $_FILES['bsp']['tmp_name'], $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/maps/$bspname" ) ) {
			$this->error( "file" );
			return;
		}
		if( $cfgid == 100 ) {
			for( $i = 0; $i < $this->pcfg->getServerCount(); $i++ ) {
				if( $i != $cfgid ) {
					if( $hastext ) {
						copy( $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/maps/$descname", $this->pcfg->getHLDSPathAt($i) . "/" . $this->pcfg->getModAt($i) . "/maps/$descname" );
					}
					copy( $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/maps/$bspname", $this->pcfg->getHLDSPathAt($i) . "/" . $this->pcfg->getModAt($i) . "/maps/$bspname" );
				}
			}
		}
		$this->thankyou( "uploadmap" );	
	}
	function form_mapcycle() {
		$cfgid = $_REQUEST['cfgid'];
		$mapcycle = trim( $_POST['mapcycle'] );
		if( empty($mapcycle) ) {
			$this->error( "mapcycle" );
			return;
		}
		$fw = fopen( $this->pcfg->getHLDSPathAt($cfgid) . "/" . $this->pcfg->getModAt($cfgid) . "/mapcycle.txt", "w" );
		fwrite( $fw, $mapcycle );
		fclose( $fw );
		$this->thankyou( "mapcycle" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class cat_log {
	var $text, $display, $id, $sub, $ver;
	function cat_log( $v ) {
		$this->ver = $v;
		$this->text  = "";
		$this->display = 20;
		if( isset( $_REQUEST['sub'] ) ) { $this->sub = $_REQUEST['sub']; }
		$this->id = 0;
		if( isset( $_REQUEST['id'] ) ) { $this->id = $_REQUEST['id']; }
		if( !$this->ver->hasAccess( "LogMenu" ) ) {
			$this->ver->logout();
			return;
		}
		if( !method_exists( $this, $this->sub ) ) {
			$this->error( "subcode" );
			return;
		}
		call_user_func( array(&$this,$this->sub) );
	}
	function pending() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM report WHERE status = 0";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
		$donext = FALSE;
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$donext = TRUE;
		}
		$doprev = FALSE;
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$doprev = TRUE;
		}
 		$title = "Viewing Report Logs";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr width='100%'>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=log&sub=pending&id=$prevpos'>Previous $this->display Report Actions</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=log&sub=pending&id=$nextpos'>Next $this->display Report Actions</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%' align='left'>&nbsp;</td>
		<td width='50%' align='right'><a href='index.php?cat=log&sub=handled'>View Handled Reports</a></td>
		</tr>
		";
		$action = "SELECT * FROM report WHERE status = 0 ORDER BY id DESC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $getlog = mysql_fetch_row($result) ) {
			$id = $getlog[0];
			$reporterid = $getlog[1];
			$reporteeid = $getlog[2];
			$reporter = $getlog[3];
			$reportee = $getlog[4];
			$timestamp = $getlog[5];
			$action = $getlog[7];
			$string .= "
			<tr>
			<td align='left'>Reporter: $reporter ($reporterid)</td>
			<td align='right'><a href='index.php?cat=log&sub=form_handled&id=$id'>Handled?</a></td>
			</tr>
			<tr>
			<td colspan='2' align='left'>Reportee: $reportee ($reporteeid)</td>
			</tr>
			<tr>
			<td colspan='2'>Action Performed:<br>$action</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function handled() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM report WHERE status = 1";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Viewing Unhandled Report Logs";
		$string = "
		<div align='center' class='text'>$title</div>
		<br>
		<table class='text' align='center' width='70%' border='0' cellspacing='0' cellpadding='0'>
		<tr width='100%'>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=log&sub=handled&id=$prevpos'>Previous $this->display Report Actions</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=log&sub=handled&id=$nextpos'>Next $this->display Report Actions</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='70%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%' align='left'>&nbsp;</td>
		<td width='50%' align='right'><a href='index.php?cat=log&sub=pending'>View Unhandled Reports</a></td>
		</tr>
		<tr>
		<td colspan='2'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT * FROM report WHERE status = 1 ORDER BY id DESC LIMIT $pos, $this->display";
		$result = mysql_query($action);
		while( $getlog = mysql_fetch_row($result) ) {
			//$id = $getlog[0];
			$steamid = $getlog[1];
			$reportid = $getlog[2];
			$reporter = $getlog[3];
			$reportee = $getlog[4];
			$action = $getlog[7];
			$string .= "
			<tr>
			<td align='left'>Reporter: $reporter ($steamid)</td>
			<td align='right'>Reportee: $reportee ($reportid)</td>
			</tr>
			<tr>
			<td colspan='2'>Action Performed:<br>$action</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "</table>";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function kick() {
		$pos = $this->id;
		if( empty($pos) || $pos < 0 ) { $pos = 0; }
		$pos = $pos - ($pos % $this->display);
		$totalaction = "SELECT COUNT(*) FROM logged WHERE type = 3";
		$resultTotal = mysql_query($totalaction);
		$tempTotal = mysql_fetch_row($resultTotal);
		$total = $tempTotal[0];
		if( $total <= 0 ) {
			$this->error( "norecords" );
			return;
		}
 		$title = "Viewing Kicked Logs";
		$string = "
		<div align='center' class='titles'>$title</div>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr width='100%'>
		";
		$prevpos = $pos - $this->display;
		if( $prevpos >= 0 ) {
			$string .= "<td align='left' width='50%'>
			<a href='index.php?cat=log&sub=kick&id=$prevpos'>Previous $this->display Kick Actions</a></td>";
		} else {
			$string .= "<td align='left' width='50%'>&nbsp;</td>";
		}
		$nextpos = $pos + $this->display;
		if( $nextpos < $total ) {
			$string .= "<td align='right' width='50%'>
			<a href='index.php?cat=log&sub=kick&id=$nextpos'>Next $this->display Kick Actions</a></td>";
		} else {
			$string .= "<td align='right' width='50%'>&nbsp;</td>";
		}
		$string .= "
		</tr>
		</table>
		<br>
		<table class='text' width='80%' align='center' border='0' cellspacing='0' cellpadding='0'>
		<tr>
		<td width='50%'>&nbsp;</td>
		<td width='50%'>&nbsp;</td>
		</tr>
		";
		$action = "SELECT timestamp, actionid, receiveid, action FROM logged WHERE type = 3 ORDER BY id DESC LIMIT $pos, $this->display";
		$res = mysql_query($action);
		while( $getlog = mysql_fetch_row($res) ) {
			$time = $getlog[0];
			$actid = $getlog[1];
			$recvid = $getlog[2];
			$action = $getlog[3];
			$kicker = $this->ver->authid2username( $actid );
			$string .= "
			<tr>
			<td align='left'>Kicker: $kicker ($actid)</td>
			<td align='right'>Kickee: ($recvid)</td>
			</tr>
			<tr>
			<td colspan='2'>Action Performed:<br>$action</td>
			</tr>
			<tr>
			<td colspan='2'>&nbsp;</td>
			</tr>
			";
		}
		$string .= "
		</table>
		";
		$s = new shell( $this->ver );
		$s->topstatic();
		$s->addcontent( $string );
		$s->bottomstatic();
		$this->text = $s->gettext();
	}
	function form_handled() {
		$reportid = 0;
		if( isset( $_REQUEST['id'] ) ) { $reportid = $_REQUEST['id']; }
		if( empty($reportid) ) {
			$this->error( "missing" );
			return;
		}
		$reportAction = "UPDATE report SET status = 1 WHERE id = $reportid";
		mysql_query($reportAction);
		$this->thankyou( "log" );
	}
	function thankyou( $thanks ) {
		$ty = new ty( $this->ver );
		$ty->whichty( $thanks );
		$this->text = $ty->gettext();
	}
	function error( $error ) {
		$e = new error( $this->ver );
		$e->whicherror( $error );
		$this->text = $e->gettext();
	}
	function gettext() { return $this->text; }
}
class inicfg {
	var $location, $iniarr;
	function inicfg( $l ) {
		$this->location = $l;
		$this->iniarr = parse_ini_file( $this->location, TRUE );
	}
	function changeValue( $major, $mykey, $value ) { $this->iniarr[$major][$mykey] = $value; }
	function getValue( $major, $mykey ) {
		$value = $this->iniarr[$major][$mykey];
		return $value;
	}
	function deleteKey( $major ) {
		foreach( $this->iniarr as $key => $sub ) {
			if( $key != $major ) { continue; }
			foreach( $sub as $subkey => $element ) { unset($this->iniarr[$key][$subkey]); }
			unset($this->iniarr[$key]);
		}
	}
	function writeIni() {
		$content = "";
		foreach( $this->iniarr as $key => $sub ) {
			$content .= "[$key]\n";
			foreach( $sub as $subkey => $element ) { $content .= "$subkey=$element\n"; }
		}
		if( !$handle = fopen( $this->location, "w" ) ) { return FALSE; }
		if( !fwrite($handle, $content) ) { return FALSE; } 
		fclose($handle);
		return TRUE;
	}
	function printArr() {
		foreach( $this->iniarr as $key => $sub ) {
			echo( "[$key]<br>" );
			foreach( $sub as $subkey => $element ) { echo( "$subkey = $element<br>" ); }
		}
	}
}


$link = mysql_connect( $dbhost, $dbuser, $dbpass );
if( !$link ) echo( mysql_error() );
if( !mysql_select_db( $database ) ) echo( mysql_error() );

$main = new main( $pcfg );

mysql_close( $link );
?>